function xNew = instant(AntStateVar,Ent,DeltaT,Param )

% System inputs:
Qi = Ent(1) ;

% Previous instant predictions for the state variables:
hT1_ant = AntStateVar(1) ;
hT2_ant = AntStateVar(2) ;
hT3_ant = AntStateVar(3) ;

% System Parameters
AT1 = Param(1) ;
AT2 = Param(2) ;
AT3 = Param(3) ;
Rv1 = Param(4) ;
Rv2 = Param(5) ;
Rv3 = Param(6) ;
LeakageT1 = Param(7) ;
LeakageT2 = Param(8) ;
LeakageT3 = Param(9) ;
StuckV1 = Param(10) ;
StuckV2 = Param(11) ;
StuckV3 = Param(12) ;

% Transitional model equations:
q1 = sqrt( abs( hT1_ant - hT2_ant )) ./ Rv1 .* StuckV1 ;
q2 = sqrt( abs( hT2_ant - hT3_ant )) ./ Rv2 .* StuckV2 ;
q3 = sqrt( abs( hT3_ant )) ./ Rv3 .* StuckV3 ;
qfuga1 = sqrt( abs( hT1_ant )) .* LeakageT1 ;
qfuga2 = sqrt( abs( hT2_ant )) .* LeakageT2 ;
qfuga3 = sqrt( abs( hT3_ant )) .* LeakageT3 ;
d_hT1 = ( Qi - q1 - qfuga1 )./ AT1 ;
d_hT2 = ( q1 - q2 - qfuga2 )./ AT2 ;
d_hT3 = ( q2 - q3 - qfuga3 )./ AT3 ;
hT1 = ( d_hT1 *DeltaT ) + hT1_ant ;
hT2 = ( d_hT2 *DeltaT ) + hT2_ant ;
hT3 = ( d_hT3 *DeltaT ) + hT3_ant ;

% Observational model equations:
hT1mes = hT1_ant ;
hT2mes = hT2_ant ;
hT3mes = hT3_ant ;

% Outputs:
xNew(1) = q1;
xNew(2) = q2;
xNew(3) = q3;
xNew(4) = qfuga1;
xNew(5) = qfuga2;
xNew(6) = qfuga3;
xNew(7) = d_hT1;
xNew(8) = d_hT2;
xNew(9) = d_hT3;
xNew(10) = hT1;
xNew(11) = hT2;
xNew(12) = hT3;
xNew(13) = hT1mes;
xNew(14) = hT2mes;
xNew(15) = hT3mes;

end