%Simulation Model: Modelo 01(Cadena 01)
function xNew = simulation(AntStateVar,Ent,DeltaT,Param,DiscNode,MesVar)

% System inputs:
Qi = Ent(1) ;

% Previous instant predictions for the state variables:
hT1_ant = AntStateVar(1) ;

% System Parameters:
AT1 = Param(1) ;
AT2 = Param(2) ;
AT3 = Param(3) ;
Rv1 = Param(4) ;
Rv2 = Param(5) ;
Rv3 = Param(6) ;
LeakageT1 = Param(7) ;
LeakageT2 = Param(8) ;
LeakageT3 = Param(9) ;
StuckV1 = Param(10) ;
StuckV2 = Param(11) ;
StuckV3 = Param(12) ;

% Discrepancy nodes: 
%hT1mes = DiscNode(1) ;

% Experiment variables measured: 
hT2mes = MesVar(1) ;
hT1mes = MesVar(2) ;

% Model equations: 
hT2 = hT2mes ;
q1 = sqrt( abs( hT1_ant - hT2 )) ./ Rv1 .* StuckV1 ;
qfuga1 = sqrt( abs( hT1_ant )) .* LeakageT1 ;
d_hT1 = ( Qi - q1 - qfuga1 )./ AT1 ;
hT1 = ( d_hT1 * DeltaT ) + hT1_ant ;
hT1mes = hT1 ;

% Outputs:
%  - Values to update state vars
%  - Discrepancy nodes
xNew(1) = hT1;
xNew(2) = hT1mes;

end