%Simulation Model: Modelo 03(Cadena 02)
function xNew = simulation(AntStateVar,Ent,DeltaT,Param,DiscNode,MesVar)

% System inputs:
% Not needed

% Previous instant predictions for the state variables:
hT3_ant = AntStateVar(1) ;

% System Parameters:
Rv1 = Param(1) ;
Rv2 = Param(2) ;
Rv3 = Param(3) ;
AT1 = Param(4) ;
AT2 = Param(5) ;
AT3 = Param(6) ;
LeakageT1 = Param(7) ;
LeakageT2 = Param(8) ;
LeakageT3 = Param(9) ;
StuckV1 = Param(10) ;
StuckV2 = Param(11) ;
StuckV3 = Param(12) ;

% Discrepancy nodes: 
%HT3mes = DiscNode(1) ;

% Experiment variables measured: 
HT2mes = MesVar(1) ;
HT3mes = MesVar(2) ;

% Model equations: 
hT2 = HT2mes ;
q2 = sqrt( abs ( hT2 - hT3_ant ) ) / Rv2 * StuckV2 ; 
q3 = sqrt( abs ( hT3_ant ) ) / Rv3 * StuckV3 ;
qf3 = sqrt( abs ( hT3_ant ) ) * LeakageT3;
d_hT3 = ( q2 - q3 - qf3 ) / AT3 ;
hT3 = ( d_hT3 * DeltaT ) + hT3_ant ;
HT3mes = hT3 ;

% Outputs:
%  - Values to update state vars
%  - Discrepancy nodes
xNew(1) = hT3;
xNew(2) = HT3mes;

end