%Simulation Model: Modelo 05(Cadena 03)
function xNew = simulation(AntStateVar,Ent,DeltaT,Param,DiscNode,MesVar)

% System inputs:
% Not needed

% Previous instant predictions for the state variables:
hT2_ant = AntStateVar(1) ;

% System Parameters:
Rv1 = Param(1) ;
Rv2 = Param(2) ;
Rv3 = Param(3) ;
AT1 = Param(4) ;
AT2 = Param(5) ;
AT3 = Param(6) ;
LeakageT1 = Param(7) ;
LeakageT2 = Param(8) ;
LeakageT3 = Param(9) ;
StuckV1 = Param(10) ;
StuckV2 = Param(11) ;
StuckV3 = Param(12) ;

% Discrepancy nodes: 
%HT2mes = DiscNode(1) ;

% Experiment variables measured: 
HT1mes = MesVar(1) ;
HT3mes = MesVar(2) ;
HT2mes = MesVar(3) ;

% Model equations: 
hT1 = HT1mes ;
hT3 = HT3mes ;
q1 = sqrt( abs ( hT1 - hT2_ant ) ) / Rv1 * StuckV1 ; 
q2 = sqrt( abs ( hT2_ant - hT3 ) ) / Rv2 * StuckV2 ; 
qf2 = sqrt( abs ( hT2_ant ) ) * LeakageT2;
d_hT2 = ( q1 - q2 - qf2 ) / AT2 ;
hT2 = ( d_hT2 * DeltaT ) + hT2_ant ;
HT2mes = hT2 ;

% Outputs:
%  - Values to update state vars
%  - Discrepancy nodes
xNew(1) = hT2;
xNew(2) = HT2mes;

end