/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package generadorexperimentosdiagnosis;

import java.util.ArrayList;
import java.util.Iterator;

/**
 *
 * @author David Rubio + Luis Miguel Villarroel
 */

//Módulo que realiza las tareas de conversión de modelos de la notación
//"Espacio de Estados" a la notación "Entrada / Salida"
public class ConversorModelos {
    Boolean ficherosCargados;       //Indica si ya se han cargado los ficheros necesarios
    Boolean modeloConvertido;       //Indica si ya se ha convertido el modelo
    ModeloSistema modelo;           //Modelo de sistema con el que se trabaja
    
    //Método de creación
    public ConversorModelos(ModeloSistema m){
        modelo = m;
        ficherosCargados = false;
        modeloConvertido = false;
    }
    
    //Establece a verdadero el atributo "ficherosCargados"
    public void setFicherosCargados(){
        this.ficherosCargados = true;
    }
    
    //Establece a verdadero el atributo "modeloConvertido"
    public void setModeloConvertido(){
        this.modeloConvertido = true;
    }
    
    //Genera por líneas el modelo en notación E/S
    public ArrayList<String> convertirModelo(){
        int numEcuacion = 1;
        
        // Primero añadimos las ecuaciones diferenciales
        ArrayList<String> lista = new ArrayList<String>();
        String variable;
        Iterator i = modelo.variablesEstado.iterator();
        while(i.hasNext()){
            variable = (String)i.next();
            lista.add("ec" + numEcuacion + " d/dt");
            lista.add(variable);
            lista.add("d_" + variable);
            lista.add("$");
            lista.add("$");
            lista.add(variable);
            lista.add("d_" + variable);
            lista.add("$");
            lista.add("$");
            numEcuacion++;
        }
        
        // A continuación ponemos el resto de ecuaciones en orden, de manera que 
        // para calcular una ecuación, sólo sean necesarios datos ya conocidos.
        ArrayList<String> variablesIntermedias = new ArrayList<String>();
        String ecuacion;
        i = modelo.listaEcuaciones.iterator();
        Iterator j;
        while(i.hasNext()){
            lista.add("ec" + numEcuacion);
            ecuacion = (String)i.next();
            ArrayList<String> cola = new ArrayList<String>();
            String partes[] = ecuacion.split(" = ");
            
            //variables intermedias (no observadas)
            j = variablesIntermedias.iterator();
            while(j.hasNext()){
                variable = (String)j.next();
                if(partes[1].contains("" + variable + " ")){
                    lista.add(variable);
                    cola.add(variable);
                }
            }
            
            //variables de estado (no observadas)
            j = modelo.variablesEstado.iterator();
            while(j.hasNext()){
                variable = (String)j.next();
                if(partes[1].contains("" + variable + " ")){
                    lista.add(variable);
                    cola.add(variable);
                }
            }
            
            //si encontramos una variable intermedia la guardamos en la lista
            //para las siguientes iteraciones. El orden de las ecuaciones es fundamental
            if(!modelo.variablesSalida.contains(partes[0])){
                lista.add(partes[0]);
                if(!variablesIntermedias.contains(partes[0])){
                    variablesIntermedias.add(partes[0]);
                }
            }
            lista.add("$");
            
            //variables de entrada (observadas)
            j = modelo.variablesEntrada.iterator();
            while(j.hasNext()){
                variable = (String)j.next();
                if(partes[1].contains("" + variable + " ")){
                    lista.add(variable);
                    cola.add(variable);
                }
            }
            
            //variables de salida (observadas)
            j = modelo.variablesSalida.iterator();
            while(j.hasNext()){
                variable = (String)j.next();
                if(partes[1].contains("" + variable + " ")){
                    lista.add(variable);
                    cola.add(variable);
                }
            }
            if(modelo.variablesSalida.contains(partes[0])){
                lista.add(partes[0]);
            }
            lista.add("$");
            
            //interpretaciones
            lista.add(partes[0]);
            j = cola.iterator();
            while(j.hasNext()){
                variable = (String)j.next();
                lista.add(variable);
            }
            
            //Modificado por David Rubio    31/8/14
            //Añade la interpretación inversa a las del tipo Y_obs = Y_est
            if(cola.size()==1 && modelo.variablesSalida.contains(partes[0]) && modelo.variablesEstado.contains(cola.get(0))){
                lista.add("$");
                lista.add(cola.get(0));
                lista.add(partes[0]);
            }
            lista.add("$");
            lista.add("$");
            numEcuacion++;
        }
        lista.add("$");
        return lista;
    }
}
