/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package generadorexperimentosdiagnosis;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Font;
import java.awt.Frame;
import java.awt.GridLayout;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

/**
 *
 * @author David Rubio + Luis Miguel Villarroel
 */

//Lanza un formulario para que el usuario seleccione los parámetros
//que se considerarán en la creación del fichero de fallos paramétricos
public class DialogoParametros extends JDialog implements ActionListener {

    public Boolean valido = false;
    public ModeloSistema modelo;
    //Componentes de la ventana
    private JPanel jContentPane = null;
    private JButton botonAceptar = null;
    private JButton botonCancelar = null;
    private JTextArea etiquetaNombre = null;
    public JCheckBox jcb[];

    //Método de creación
    public DialogoParametros(Frame owner, ModeloSistema m) {
        super(owner);
        this.setTitle("Parameters");
        this.modelo = m;
        int numfilas;
        if (modelo.parametros.size() < 6) {
            numfilas = 6;
        } else {
            numfilas = modelo.parametros.size();
        }
        jcb = new JCheckBox[numfilas];
        initialize();
    }

    //Inicializa los distintos componentes de la ventana, ayudándose
    //de las funciones auxiliares getJContentPane(), getJScrollPane(),
    //getBotonAceptar() y getBotonCancelar()
    private void initialize() {
        this.setSize(280, 375);
        getJContentPane();
        this.setContentPane(getJContentPane());
        this.setResizable(false);
        this.setModal(true);
        this.setLocationRelativeTo(null);
        this.setVisible(true);
    }

    //Construye el panel principal
    private JPanel getJContentPane() {
        if (jContentPane == null) {
            etiquetaNombre = new JTextArea();
            etiquetaNombre.setBounds(new Rectangle(20, 25, 350, 35));
            etiquetaNombre.setText("        Select the faulty parameters        ");
            etiquetaNombre.setFont(new Font("Helvetica", 1, 12));
            etiquetaNombre.setOpaque(false);
            etiquetaNombre.setEditable(false);
            jContentPane = new JPanel();
            jContentPane.setLayout(null);
            jContentPane.add(getBotonCancelar(), BorderLayout.SOUTH);
            jContentPane.add(getBotonAceptar(), BorderLayout.SOUTH);
            jContentPane.add(etiquetaNombre, null);
            jContentPane.add(getJScrollPane(), null);
        }
        return jContentPane;
    }

    //Construye el panel con scroll y lo rellena con checkboxes
    private JScrollPane getJScrollPane() {
        JPanel panel = new JPanel();
        panel.setLayout(new GridLayout(jcb.length, 1));
        panel.setBackground(Color.white);
        panel.repaint();
        for (int i = 0; i < modelo.parametros.size(); i++) {
            jcb[i] = new JCheckBox(modelo.parametros.get(i).nombre);
            jcb[i].setBackground(Color.white);
            jcb[i].repaint();
            panel.add(jcb[i]);
            jcb[i].setVisible(true);
        }
        JScrollPane list = new JScrollPane(panel);
        list.setWheelScrollingEnabled(true);
        list.setBounds(new Rectangle(15, 80, 236, 189));
        return list;
    }

    //Construye el botón "Aceptar"
    private JButton getBotonAceptar() {
        if (botonAceptar == null) {
            botonAceptar = new JButton();
            botonAceptar.setText("OK");
            botonAceptar.setBounds(new Rectangle(14, 300, 115, 31));
            botonAceptar.setActionCommand("Aceptar");
            botonAceptar.addActionListener(this);
        }
        return botonAceptar;
    }

    //Construye el botón "Cancelar"
    private JButton getBotonCancelar() {
        if (botonCancelar == null) {
            botonCancelar = new JButton();
            botonCancelar.setText("Cancel");
            botonCancelar.setBounds(new Rectangle(150, 300, 115, 31));
            botonCancelar.setActionCommand("Cancelar");
            botonCancelar.addActionListener(this);

        }
        return botonCancelar;
    }

    //Administrador de eventos
    @Override
    public void actionPerformed(ActionEvent evento) {
        System.out.println(evento.getActionCommand());
        if (evento.getActionCommand().startsWith("Cancelar")) {
            this.setVisible(false);
            this.valido = false;

        } else if (evento.getActionCommand().startsWith("Aceptar")) {
            this.setVisible(false);
            if (numSelecciones() > 0) {
                this.valido = true;
            } else {
                this.valido = false;
            }
        }
    }

    //Indica la cantidad de parámetros marcados por el usuario
    public int numSelecciones() {
        int n = 0;
        for (int i = 0; i < jcb.length; i++) {
            if (jcb[i] != null && jcb[i].isSelected()) {
                n++;
            }
        }
        return n;
    }
}
