/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package generadorexperimentosdiagnosis;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Frame;
import java.awt.GridLayout;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.util.ArrayList;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;

/**
 *
 * @author David Rubio + Luis Miguel Villarroel
 */
public class DialogoUmbrales extends JDialog implements ActionListener {

    public Boolean valido = false;
    public ArrayList<String> discrepancias;
    //Componentes de la ventana
    public JPanel jContentPane = null;
    public JButton botonAceptar = null;
    public JButton botonCancelar = null;
    public JTextArea etiquetaNombre = null;
    public JLabel jl[];
    public JTextField jtf[];

    public DialogoUmbrales(Frame owner, ArrayList<String> d) {
        super(owner);
        this.setTitle("Threshold settings");
        this.discrepancias = d;
        int numfilas;
        if (discrepancias.size() < 8) {
            numfilas = 8;
        } else {
            numfilas = discrepancias.size();
        }
        jl = new JLabel[numfilas];
        jtf = new JTextField[numfilas];

        initialize();
    }

    public void initialize() {
        this.setSize(320, 400);
        getJContentPane();
        this.setContentPane(getJContentPane());
        this.setResizable(false);
        this.setModal(true);
        this.setLocationRelativeTo(null);
        this.setVisible(true);
    }

    public JPanel getJContentPane() {
        if (jContentPane == null) {
            etiquetaNombre = new JTextArea();
            etiquetaNombre.setBounds(new Rectangle(20, 15, 280, 40));
            etiquetaNombre.setText("Set each element's value. A threshold left blank\nwill be set to 0, which means zero tolerance.");
            etiquetaNombre.setFont(new Font("Helvetica", 1, 12));
            etiquetaNombre.setOpaque(false);
            etiquetaNombre.setEditable(false);
            jContentPane = new JPanel();
            jContentPane.setLayout(null);
            jContentPane.add(getBotonCancelar(), BorderLayout.SOUTH);
            jContentPane.add(getBotonAceptar(), BorderLayout.SOUTH);
            jContentPane.add(etiquetaNombre, null);
            jContentPane.add(getJScrollPane(), null);
        }
        return jContentPane;
    }

    public JScrollPane getJScrollPane() {
        JPanel panel = new JPanel();
        GridLayout gd = new GridLayout(jtf.length, 2);
        gd.setVgap(5);
        panel.setLayout(gd);
        for (int i = 0; i < discrepancias.size(); i++) {
            jl[i] = new JLabel(discrepancias.get(i));
            jtf[i] = new JTextField();
            jl[i].setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
            jtf[i].setHorizontalAlignment(JTextField.RIGHT);
            JPanel p = new JPanel();
            p.setLayout(new BoxLayout(p, BoxLayout.X_AXIS));
            p.add(jl[i]);
            p.add(Box.createRigidArea(new Dimension(15, 0)));
            p.add(jtf[i]);
            panel.add(p);
        }
        JScrollPane list = new JScrollPane(panel);
        list.setWheelScrollingEnabled(true);
        list.setBounds(new Rectangle(30, 60, 260, 260));
        return list;
    }

    public JButton getBotonAceptar() {
        if (botonAceptar == null) {
            botonAceptar = new JButton();
            botonAceptar.setText("OK");
            botonAceptar.setBounds(new Rectangle(50, 330, 80, 30));
            botonAceptar.setActionCommand("Aceptar");
            botonAceptar.addActionListener(this);
        }
        return botonAceptar;
    }

    public JButton getBotonCancelar() {
        if (botonCancelar == null) {
            botonCancelar = new JButton();
            botonCancelar.setText("Cancel");
            botonCancelar.setBounds(new Rectangle(190, 330, 80, 30));
            botonCancelar.setActionCommand("Cancelar");
            botonCancelar.addActionListener(this);

        }
        return botonCancelar;
    }

    @Override
    public void actionPerformed(ActionEvent evento) {
        System.out.println(evento.getActionCommand());
        if (evento.getActionCommand().startsWith("Cancelar")) {
            this.setVisible(false);
            this.valido = false;
        } else if (evento.getActionCommand().startsWith("Aceptar")) {
            this.setVisible(false);
            if (numSelecciones() == discrepancias.size()) {
                this.valido = true;
            } else {
                this.valido = false;
            }
        }
    }

    public int numSelecciones() {
        int n = 0;
        for (int i = 0; i < jtf.length; i++) {
            if (jtf[i] != null && !jtf[i].getText().isEmpty()) {
                n++;
            }
        }
        return n;
    }
}
