/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package generadorexperimentosdiagnosis;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.*;

/**
 *
 * @author David Rubio + Luis Miguel Villarroel
 */
//Lanza un formulario para que el usuario seleccione las variables
//que desea ver representadas en un gráfico que genera el módulo GE
public class DialogoVariablesGrafico extends JDialog implements ActionListener {
    public Boolean valido = false;
    public GeneradorExperimentos moduloGE;
    //Componentes de la ventana
    private JPanel jContentPane = null;
    private JButton botonAceptar = null;
    private JButton botonCancelar = null;
    private JTextArea etiquetaNombre = null;
    public JCheckBox jcb[];

    //Método de creación
    public DialogoVariablesGrafico(Frame owner, GeneradorExperimentos ge) {
        super(owner);
        this.setLocationRelativeTo(owner);
        this.setTitle("Variables and Parameters");
        this.moduloGE = ge;
        int numfilas;
        if (moduloGE.modeloTabla.getColumnCount() - 1 < 6) {
            numfilas = 6;
        } else {
            numfilas = moduloGE.modeloTabla.getColumnCount() - 1;
        }
        jcb = new JCheckBox[numfilas];
        initialize();
    }

    //Inicializa los distintos componentes de la ventana, ayudándose
    //de las funciones auxiliares getJContentPane(), getJScrollPane(),
    //getBotonAceptar() y getBotonCancelar()
    private void initialize() {
        this.setSize(280, 375);
        getJContentPaneGE();
        this.setContentPane(getJContentPaneGE());
        this.setResizable(false);
        this.setModal(true);
        this.setLocationRelativeTo(null);
        this.setVisible(true);
    }

    //Construye el panel principal
    private JPanel getJContentPaneGE() {
        if (jContentPane == null) {
            etiquetaNombre = new JTextArea();
            etiquetaNombre.setBounds(new Rectangle(15, 25, 350, 35));
            etiquetaNombre.setText("Select variables to be shown in the chart");
            etiquetaNombre.setFont(new Font("Helvetica", 1, 12));
            etiquetaNombre.setOpaque(false);
            etiquetaNombre.setEditable(false);
            jContentPane = new JPanel();
            jContentPane.setLayout(null);
            jContentPane.add(getBotonCancelar(), BorderLayout.SOUTH);
            jContentPane.add(getBotonAceptar(), BorderLayout.SOUTH);
            jContentPane.add(etiquetaNombre, null);
            jContentPane.add(getJScrollPane(), null);
        }
        return jContentPane;
    }

    //Construye el panel con scroll y lo rellena con checkboxes
    private JScrollPane getJScrollPane() {
        JPanel panel = new JPanel();
        panel.setLayout(new GridLayout(jcb.length, 1));
        panel.setBackground(Color.white);
        panel.repaint();
        for (int i = 1; i < moduloGE.modeloTabla.getColumnCount(); i++) {
            jcb[i - 1] = new JCheckBox(moduloGE.modeloTabla.getColumnName(i));
            jcb[i - 1].setBackground(Color.white);
            jcb[i - 1].repaint();
            panel.add(jcb[i - 1]);
            jcb[i - 1].setVisible(true);
        }
        JScrollPane list = new JScrollPane(panel);
        list.setWheelScrollingEnabled(true);
        list.setBounds(new Rectangle(15, 80, 236, 189));
        return list;
    }

    //Construye el botón "Aceptar"
    private JButton getBotonAceptar() {
        if (botonAceptar == null) {
            botonAceptar = new JButton();
            botonAceptar.setText("OK");
            botonAceptar.setBounds(new Rectangle(14, 300, 115, 31));
            botonAceptar.setActionCommand("Aceptar");
            botonAceptar.addActionListener(this);
        }
        return botonAceptar;
    }

    //Construye el botón "Cancelar"
    private JButton getBotonCancelar() {
        if (botonCancelar == null) {
            botonCancelar = new JButton();
            botonCancelar.setText("Cancel");
            botonCancelar.setBounds(new Rectangle(150, 300, 115, 31));
            botonCancelar.setActionCommand("Cancelar");
            botonCancelar.addActionListener(this);
        }
        return botonCancelar;
    }

    //Administrador de eventos
    @Override
    public void actionPerformed(ActionEvent evento) {
        System.out.println(evento.getActionCommand());
        if (evento.getActionCommand().startsWith("Cancelar")) {
            this.setVisible(false);
            this.valido = false;
        } else if (evento.getActionCommand().startsWith("Aceptar")) {
            this.setVisible(false);
            if (numSelecciones() > 0) {
                this.valido = true;
            } else {
                this.valido = false;
            }
        }
    }

    //Indica la cantidad de variables marcadas por el usuario
    public int numSelecciones() {
        int n = 0;
        for (int i = 0; i < jcb.length; i++) {
            if (jcb[i] != null && jcb[i].isSelected()) {
                n++;
            }
        }
        return n;
    }
}
