/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package generadorexperimentosdiagnosis;

import java.util.ArrayList;
import java.util.Iterator;

/**
 *
 * @author David Rubio + Luis Miguel Villarroel
 */
//Se encarga de generar los fallos paramétricos que
//ocurrirán durante la ejecución de un experimento
public class GeneradorFicheroFallos {
    Interfaz ventana;
    ModeloSistema modelo;       //Modelo de sistema con el que se trabaja
    ArrayList<Integer> indices; //lista con los índices de los parametros que van a causar fallo
    boolean valido = true;      //indica si el proceso ha acabado correctamente y los datos cargados son válidos
    ArrayList<Fallo> fallos = new ArrayList<Fallo>();   //lista con los fallos que se van a generar

    //Establece a verdadero el valor del atributo "valido"
    public void setValido(boolean v) {
        this.valido = v;
    }

    //Añade un fallo paramétrico a la lista
    public void addFallo(Fallo f) {
        this.fallos.add(f);
    }

    //Método de creación
    public GeneradorFicheroFallos(Interfaz i, ArrayList<Integer> ind, ModeloSistema m) {
        this.ventana = i;
        this.modelo = m;
        this.indices = ind;
    }

    //Construye los fallos paramétricos. Para cada parámetro causante de fallo
    //se lanza un FormularioFallo, se recogen los datos introducidos por el usuario
    //y añade el nuevo fallo a la lista
    public ArrayList<Fallo> generarFallos() {
        Iterator i = indices.iterator();
        while (i.hasNext() && valido) {
            Integer p = (Integer) i.next();
            FormularioFallo ff = new FormularioFallo(ventana, true, modelo.parametros.get(p).nombre, this);
            if (valido) {
                Fallo f = new Fallo(p + 1);
                f.setFailStep(ff.getInstante());
                f.setErrorMagnitude(ff.getMagnitud());
                f.setTipo(ff.getTipo());
                fallos.add(f.clonar());
            }
        }
        if (valido) {
            return fallos;
        } else {
            return null;
        }

    }
}
