/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package generadorexperimentosdiagnosis;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JOptionPane;
import javax.swing.table.DefaultTableModel;

/**
 *
 * @author David Rubio + Luis Miguel Villarroel
 */
public class GestorBBDD {

    public void guardarExperimento(GeneradorExperimentos exp, Interfaz ventana, String descripcion, String sistema, String nombreBBDD, String usuario, String password) {
        try {
            //se almacenan los resultados del experimento en un mismo String
            DefaultTableModel modelo = exp.modeloTabla;
            int columnas = modelo.getColumnCount();
            int filas = modelo.getRowCount();
            String datosExp = modelo.getColumnName(0);
            for (int i = 1; i < columnas; i++) {
                datosExp = datosExp + "\t" + modelo.getColumnName(i);
            }
            datosExp = datosExp + "\n";

            for (int i = 0; i < filas; i++) {
                datosExp = datosExp + modelo.getValueAt(i, 0).toString();
                for (int j = 1; j < columnas; j++) {
                    datosExp = datosExp + "\t" + modelo.getValueAt(i, j).toString();
                }
                datosExp = datosExp + "\n";
            }
            
            //se crea y lanza la consulta de insercción del experimento
            String query = "insert into experimento (descripcion, sistema, datos) values('" + descripcion + "', '" + sistema + "', '" + datosExp + "')";
            Connection conexion = DriverManager.getConnection("jdbc:mysql://localhost/" + nombreBBDD, usuario, password);
            Statement s = conexion.createStatement();
            s.executeUpdate(query);

            //se crean y lanzan las consultas de inserción de los fallos
            query = "select last_insert_id()";
            ResultSet rs = s.executeQuery(query);
            int id = 0;
            if (rs.next()) {
                id = rs.getInt(1);
            }
            
            Fallo f;
            for (int i = 0; i < exp.fallos.size(); i++) {
                f = exp.fallos.get(i);
                query = "insert into modo_funcionamiento (IDexp, indiceParametro, tipo, failStep, magnitude) values(" + id + ", "
                        + f.numParam + ", '" + f.tipo + "', " + f.failStep + ", " + f.errorMagnitude + ")";
                s.executeUpdate(query);
            }
        } catch (SQLException ex) {
            Logger.getLogger(GestorBBDD.class.getName()).log(Level.SEVERE, null, ex);
            muestraError("Unable to connect to the DataBase. Please check username and password.", ventana);
        }
    }

    public void cargarExperimento(GeneradorExperimentos exp, Interfaz ventana, String nombreBBDD, String usuario, String password) {
        try {
            Connection conexion = DriverManager.getConnection("jdbc:mysql://localhost/" + nombreBBDD, usuario, password);
            Statement s = conexion.createStatement();
            String query = "select count(*) from experimento";
            ResultSet rs = s.executeQuery(query);
            int numRegistros = 0;
            if (rs.next()) {
                numRegistros = rs.getInt(1);
            }

            if (numRegistros > 0) {
                Object[] posiblesValores = new Object[numRegistros];
                query = "select * from experimento";
                rs = s.executeQuery(query);
                int i = 0;
                while (rs.next()) {
                    posiblesValores[i] = "Sistema: " + rs.getString(3) + ". Descripción: " + rs.getString(2) + ".";
                    i++;
                }
                Object selectedValue = JOptionPane.showInputDialog(ventana,
                        "Select the desired experiment among the available ones in the Database", "Warning",
                        JOptionPane.INFORMATION_MESSAGE, null, posiblesValores, posiblesValores[0]);

                for (int j = 0; j < posiblesValores.length; j++) {
                    if (selectedValue != null && posiblesValores[j].toString().compareTo(selectedValue.toString()) == 0) {
                        rs.beforeFirst();
                        i = 0;
                        while (rs.next()) {
                            if (i == j) {
                                presentarFallos(rs.getInt(1), exp, ventana, nombreBBDD, usuario, password);     //se muestran los fallos del experimento seleccionado
                                String datos = rs.getString(4);
                                String lineas[] = datos.split("\n");
                                DefaultTableModel modeloTabla = new DefaultTableModel();
                                String[] nombres = lineas[0].split("\t");
                                for (int k = 0; k < nombres.length; k++) {
                                    modeloTabla.addColumn(nombres[k]);
                                }
                                Object[] valores;
                                for (int k = 1; k < lineas.length; k++) {
                                    valores = lineas[k].split("\t");
                                    modeloTabla.addRow(valores);
                                }
                                exp.setModeloTabla(modeloTabla);
                            }
                            i++;
                        }
                    }
                }
            }

        } catch (SQLException ex) {
            Logger.getLogger(GestorBBDD.class.getName()).log(Level.SEVERE, null, ex);
            muestraError("Unable to connect to the DataBase. Please check username and password", ventana);
        }
    }

    public void presentarFallos(int id, GeneradorExperimentos exp, Interfaz ventana, String nombreBBDD, String usuario, String password) {
        try {
            Connection conexion = DriverManager.getConnection("jdbc:mysql://localhost/" + nombreBBDD, usuario, password);
            Statement s = conexion.createStatement();
            String query = "select indiceParametro, tipo, failStep, magnitude from modo_funcionamiento where IDexp=" + id;
            ResultSet rs = s.executeQuery(query);

            DefaultTableModel m = new DefaultTableModel();
            m.addColumn("Parameter");
            m.addColumn("Type");
            m.addColumn("Fault Instant");
            m.addColumn("Magnitude");
            Object[] valores;
            while (rs.next()) {
                valores = new Object[4];
                valores[0] = exp.modelo.parametros.get(rs.getInt(1) - 1).nombre;
                valores[1] = rs.getString(2);
                valores[2] = rs.getInt(3);
                valores[3] = rs.getDouble(4);
                m.addRow(valores);
            }
            DialogoModoFuncionamiento d = new DialogoModoFuncionamiento(ventana, true, m);
        } catch (SQLException ex) {
            Logger.getLogger(GestorBBDD.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    public void muestraError(String err, Interfaz ventana) {
        JOptionPane.showMessageDialog(ventana, err, "Error", JOptionPane.ERROR_MESSAGE);
    }
}
