/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package generadorexperimentosdiagnosis;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.FilenameFilter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.filechooser.FileNameExtensionFilter;
import javax.swing.table.DefaultTableModel;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import org.xml.sax.SAXException;

/**
 *
 * @author David Rubio + Luis Miguel Villarroel
 */
//Clase encargada de gestionar las lecturas y escrituras
//de los distintos tipos de ficheros que maneja la aplicación
public class GestorFicheros {
    JFileChooser fc = new JFileChooser(".");

    //Carga automática de los ficheros de entrada del módulo de G.E.
    //a partir de un fichero de rutas
    public void cargarDatosCM(ModeloSistema modelo) {
        FiltroFicheros filtro = new FiltroFicheros("txt");
        fc.setSelectedFile(new File(""));
        fc.setDialogTitle("Select the file containing the input files paths");
        fc.setFileFilter(filtro);
        int returnVal = fc.showOpenDialog(fc);
        if (returnVal == JFileChooser.APPROVE_OPTION) {
            String nomFichero = fc.getSelectedFile().getAbsolutePath();
            String linea;
            String ruta;
            try {
                BufferedReader fichero = new BufferedReader(new InputStreamReader(new FileInputStream(new File(nomFichero))));
                linea = fichero.readLine();
                ruta = linea.split(": ")[1];
                cargarEcuacionesSistema(modelo, ruta);
                linea = fichero.readLine();
                ruta = linea.split(": ")[1];
                cargarVarEntradaSistema(modelo, ruta);
            } catch (Exception e) {
                System.err.printf(e.getMessage());
            }
        }
    }

    //Carga automática de los ficheros de entrada del módulo de G.E.
    //a partir de un fichero de rutas
    public void cargarDatosGE(ModeloSistema modelo, GeneradorExperimentos exp) {
        FiltroFicheros filtro = new FiltroFicheros("txt");
        fc.setSelectedFile(new File(""));
        fc.setDialogTitle("Select the file containing the input files paths");
        fc.setFileFilter(filtro);
        int returnVal = fc.showOpenDialog(fc);
        if (returnVal == JFileChooser.APPROVE_OPTION) {
            String nomFichero = fc.getSelectedFile().getAbsolutePath();
            String linea;
            String ruta;
            try {
                BufferedReader fichero = new BufferedReader(new InputStreamReader(new FileInputStream(new File(nomFichero))));
                String etiqueta;
                while ((linea = fichero.readLine()) != null) {
                    etiqueta = linea.split(": ")[0];
                    ruta = linea.split(": ")[1];
                    if (etiqueta.startsWith("EDOs")) {
                        cargarEcuacionesSistema(modelo, ruta);
                    } else if (etiqueta.startsWith("Variables")) {
                        cargarVarEntradaSistema(modelo, ruta);
                    } else if (etiqueta.startsWith("Condiciones iniciales")) {
                        cargarCondicionesIniciales(exp, ruta);
                    } else if (etiqueta.startsWith("Configuracion del experimento")) {
                        cargarConfiguracionExperimento(exp, ruta);
                    } else if (etiqueta.startsWith("Datos de entrada")) {
                        cargarValoresEntrada(exp, ruta);
                    } else if (etiqueta.startsWith("Parametros")) {
                        cargarParametros(modelo, ruta);
                    } else if (etiqueta.startsWith("Fallos")) {
                        cargarFallos(exp, ruta);
                    }
                }
            } catch (Exception e) {
                System.err.printf(e.getMessage());
            }
        }
    }

    //Carga automática de los ficheros de entrada del módulo de G.M.S.
    //a partir de un fichero de rutas
    public void cargarDatosGMS(ModeloSistema modelo) {
        FiltroFicheros filtro = new FiltroFicheros("txt");
        fc.setSelectedFile(new File(""));
        fc.setDialogTitle("Select the file containing the input files paths");
        fc.setFileFilter(filtro);
        int returnVal = fc.showOpenDialog(fc);
        if (returnVal == JFileChooser.APPROVE_OPTION) {
            String nomFichero = fc.getSelectedFile().getAbsolutePath();
            String linea;
            String ruta;
            try {
                BufferedReader fichero = new BufferedReader(new InputStreamReader(new FileInputStream(new File(nomFichero))));
                linea = fichero.readLine();
                ruta = linea.split(": ")[1];
                cargarEcuacionesSistema(modelo, ruta);
                linea = fichero.readLine();
                ruta = linea.split(": ")[1];
                cargarVarEntradaSistema(modelo, ruta);
                String etiqueta;
                while ((linea = fichero.readLine()) != null) {
                    etiqueta = linea.split(": ")[0];
                    ruta = linea.split(": ")[1];
                    if (etiqueta.startsWith("Modelo de CPCs")) {
                        cargarModeloCPC(modelo, ruta);
                    }
                }
            } catch (Exception e) {
                System.err.printf(e.getMessage());
            }
        }
    }

    public void cargarDatosDX(ModeloSistema modelo, GeneradorExperimentos ge) {
        FiltroFicheros filtro = new FiltroFicheros("txt");
        fc.setSelectedFile(new File(""));
        fc.setDialogTitle("Select the file containing the input files paths");
        fc.setFileFilter(filtro);
        int returnVal = fc.showOpenDialog(fc);
        if (returnVal == JFileChooser.APPROVE_OPTION) {
            String nomFichero = fc.getSelectedFile().getAbsolutePath();
            String linea;
            String ruta;
            try {
                BufferedReader fichero = new BufferedReader(new InputStreamReader(new FileInputStream(new File(nomFichero))));
                linea = fichero.readLine();
                linea = fichero.readLine();
                ruta = linea.split(": ")[1];
                cargarVarEntradaSistema(modelo, ruta);
                String etiqueta;
                while ((linea = fichero.readLine()) != null) {
                    etiqueta = linea.split(": ")[0];
                    ruta = linea.split(": ")[1];
                    if (etiqueta.startsWith("Resultado del experimento")) {
                        cargarExperimento(ge, ruta);
                    } else if (etiqueta.startsWith("Modelos de simulacion")) {
                        cargarModSim(modelo, ruta);
                    } else if (etiqueta.startsWith("Condiciones iniciales")) {
                        cargarCondicionesIniciales(ge, ruta);
                    } else if (etiqueta.startsWith("Configuracion del experimento")) {
                        cargarConfiguracionExperimento(ge, ruta);
                    } else if (etiqueta.startsWith("Modelo de CPCs")) {
                        cargarModeloCPC(modelo, ruta);
                    } else if (etiqueta.startsWith("Parametros")) {
                        cargarParametros(modelo, ruta);
                    } else if (etiqueta.startsWith("Fallos")) {
                        cargarFallos(ge, ruta);
                    }
                }
            } catch (Exception e) {
                System.err.printf(e.getMessage());
            }
        }
    }

    //Carga las ecuaciones de un modelo contenidas en un fichero .m
    //Versión automática
    public void cargarEcuacionesSistema(ModeloSistema modelo, String ruta) {
        String nomFichero = ruta;
        modelo.nombre = nomFichero.substring(nomFichero.lastIndexOf("\\") + 1, nomFichero.indexOf("."));
        String linea;
        try {
            BufferedReader fichero = new BufferedReader(new InputStreamReader(new FileInputStream(new File(nomFichero))));
            while ((linea = fichero.readLine()) != null) {
                modelo.addEcuacionLista(linea);
            }
        } catch (Exception e) {
            System.err.printf(e.getMessage());
        }
    }

    //Carga las ecuaciones de un modelo contenidas en un fichero .m
    //Versión manual
    public void cargarEcuacionesSistema(ModeloSistema modelo) {
        FiltroFicheros filtro = new FiltroFicheros("m");
        fc.setSelectedFile(new File(""));
        fc.setDialogTitle("Select the file that contains the System Model (ODEs)");
        fc.setFileFilter(filtro);
        int returnVal = fc.showOpenDialog(fc);
        if (returnVal == JFileChooser.APPROVE_OPTION) {
            String nomFichero = fc.getSelectedFile().getAbsolutePath();
            modelo.nombre = nomFichero.substring(nomFichero.lastIndexOf("\\") + 1, nomFichero.lastIndexOf("."));
            String linea;
            try {
                BufferedReader fichero = new BufferedReader(new InputStreamReader(new FileInputStream(new File(nomFichero))));
                while ((linea = fichero.readLine()) != null) {
                    modelo.addEcuacionLista(linea);
                }
            } catch (Exception e) {
                System.err.printf(e.getMessage());
            }
        }
    }

    //Carga las variables de entrada de un modelo contenidas en un fichero .txt
    //Versión automática
    public void cargarVarEntradaSistema(ModeloSistema modelo, String ruta) {
        String nomFichero = ruta;
        String linea, variables [];
        try {
            BufferedReader fichero = new BufferedReader(new InputStreamReader(new FileInputStream(new File(nomFichero))));
            while ((linea = fichero.readLine()) != null) {
                modelo.addVarEntradaLista(linea);
            }
        } catch (Exception e) {
            System.err.printf(e.getMessage());
        }
        
        //Una vez cargadas las variables por líneas, lo recorremos para
        //extraer la información de cada una.
        //Primero las variables de estado
        String cadena = modelo.listaVariables.get(0);
        Pattern patron = Pattern.compile("X = \\{(.+)\\};");
        Matcher matcher = patron.matcher(cadena);
        matcher.find();
        String cadena2 = matcher.group(1).replace("'", "").replace(",", " ");
        if (cadena2.length() > 0) {
            variables = cadena2.split(" ");
            for (int j = 0; j < variables.length; j++) {
                modelo.addVariableEstado(variables[j]);
            }

            //Con las variables de estado cargadas, ya se pueden añadir
            //las ecuaciones integrales correspondientes
            for (int j = 0; j < variables.length; j++) {
                String var = variables[j];
                String ecuacionIntegral = var + " = ( d_" + var + " * DeltaT ) + " + var + "_ant ;";
                modelo.addEcuacionIntegralLista(ecuacionIntegral);
            }
        }

        //Luego las variables de salida
        cadena = modelo.listaVariables.get(1);
        patron = Pattern.compile("Y = \\{(.+)\\};");
        matcher = patron.matcher(cadena);
        matcher.find();
        cadena2 = matcher.group(1).replace("'", "").replace(",", " ");
        variables = cadena2.split(" ");
        for (int j = 0; j < variables.length; j++) {
            modelo.addVariableSalida(variables[j]);
        }

        //Luego las variables de entrada
        cadena = modelo.listaVariables.get(2);
        patron = Pattern.compile("U = \\{(.+)\\};");
        matcher = patron.matcher(cadena);
        matcher.find();
        cadena2 = matcher.group(1).replace("'", "").replace(",", " ");
        variables = cadena2.split(" ");
        for (int j = 0; j < variables.length; j++) {
            modelo.addVariableEntrada(variables[j]);
        }
    }

    //Carga las variables de entrada de un modelo contenidas en un fichero .txt
    //Versión manual
    public void cargarVarEntradaSistema(ModeloSistema modelo) {
        FiltroFicheros filtro = new FiltroFicheros("txt");
        fc.setSelectedFile(new File(""));
        fc.setDialogTitle("Select file that contains the system variables");
        fc.setFileFilter(filtro);
        int returnVal = fc.showOpenDialog(fc);
        if (returnVal == JFileChooser.APPROVE_OPTION) {
            String nomFichero = fc.getSelectedFile().getAbsolutePath();
            String linea;
            try {
                BufferedReader fichero = new BufferedReader(new InputStreamReader(new FileInputStream(new File(nomFichero))));
                while ((linea = fichero.readLine()) != null) {
                    modelo.addVarEntradaLista(linea);
                }
            } catch (Exception e) {
                System.err.printf(e.getMessage());
            }

            //Una vez cargadas las variables por líneas, lo recorremos para
            //extraer la información de cada una.
            //Primero las variables de estado
            String variables [];
            String cadena = modelo.listaVariables.get(0);
            Pattern patron = Pattern.compile("X = \\{(.+)\\};");
            Matcher matcher = patron.matcher(cadena);
            matcher.find();
            String cadena2 = matcher.group(1).replace("'", "").replace(",", " ");
            if (cadena2.length() > 0) {
                variables = cadena2.split(" ");
                for (int j = 0; j < variables.length; j++) {
                    modelo.addVariableEstado(variables[j]);
                }
                //Con las variables de estado cargadas, ya se pueden añadir
                //las ecuaciones integrales correspondientes
                for (int j = 0; j < variables.length; j++) {
                    String var = variables[j];
                    String ecuacionIntegral = var + " = ( d_" + var + " *DeltaT ) + " + var + "_ant ;";
                    modelo.addEcuacionIntegralLista(ecuacionIntegral);
                }
            }

            //Luego las variables de salida
            cadena = modelo.listaVariables.get(1);
            patron = Pattern.compile("Y = \\{(.+)\\};");
            matcher = patron.matcher(cadena);
            matcher.find();
            cadena2 = matcher.group(1).replace("'", "").replace(",", " ");
            variables = cadena2.split(" ");
            for (int j = 0; j < variables.length; j++) {
                modelo.addVariableSalida(variables[j]);
            }

            //Luego las variables de entrada
            cadena = modelo.listaVariables.get(2);
            patron = Pattern.compile("U = \\{(.+)\\};");
            matcher = patron.matcher(cadena);
            matcher.find();
            cadena2 = matcher.group(1).replace("'", "").replace(",", " ");
            variables = cadena2.split(" ");
            for (int j = 0; j < variables.length; j++) {
                modelo.addVariableEntrada(variables[j]);
            }
        }
    }

    //Carga los MEMs contenidos en un fichero de texto generado por la herramienta de CPCs
    //Versión automática
    public void cargarModeloCPC(ModeloSistema modelo, String ruta) {
        ArrayList <String> varUsadas = new ArrayList <String> ();
        String nomFichero = ruta;
        String linea;
        try {
            BufferedReader fichero = new BufferedReader(new InputStreamReader(new FileInputStream(new File(nomFichero))));
            while ((linea = fichero.readLine()) != null) {
                if (linea.compareTo("") != 0) {
                    modelo.addLineaCPC(linea);
                }
            }
        } catch (Exception e) {
            System.err.printf(e.getMessage());
        }

        //Una vez cargado todo el modelo por líneas, lo recorremos para
        //extraer la información de cada una
        Iterator i = modelo.modeloCPC.iterator();
        String cadena;
        while (i.hasNext()) {
            cadena = (String) i.next();
            while (cadena.startsWith("Modelo")) {
                MEM mod = new MEM();
                mod.nombre = cadena.replace(":", "");
                cadena = (String) i.next();
                while (!cadena.startsWith("Modelo") && !cadena.startsWith("*****")) {
                    Pattern patron = Pattern.compile("(.+) := (.+)\\((.+)\\)");
                    Matcher matcher = patron.matcher(cadena);
                    matcher.find();
                    
                    Interpretacion ec = new Interpretacion();
                    ec.nombre = matcher.group(2);
                    ec.variableCabeza = matcher.group(1);
                    if (!varUsadas.contains(ec.variableCabeza)) {
                        varUsadas.add(ec.variableCabeza);
                    }
                    String palabra[] = matcher.group(3).split(", ");
                    for (int j = 0; j < palabra.length; j++) {
                        ec.addVariableCola(palabra[j]);
                        if (!varUsadas.contains(palabra[j]) && !modelo.variablesEntrada.contains(palabra[j])) {
                            varUsadas.add(palabra[j]);
                        }
                    }
                    mod.addInterpretacion(ec);
                    cadena = (String) i.next();
                }
                modelo.addMEM(mod);
            }
        }
    }

    //Carga los MEMs contenidos en un fichero de texto generado por la herramienta de CPCs
    //Versión manual
    public void cargarModeloCPC(ModeloSistema modelo) {
        ArrayList <String> varUsadas = new ArrayList <String> ();
        FiltroFicheros filtro = new FiltroFicheros("txt");
        fc.setSelectedFile(new File(""));
        fc.setDialogTitle("Select the file that contains the CPC results");
        fc.setFileFilter(filtro);
        int returnVal = fc.showOpenDialog(fc);
        if (returnVal == JFileChooser.APPROVE_OPTION) {            
            String nomFichero = fc.getSelectedFile().getAbsolutePath();
            String linea;
            try {
                BufferedReader fichero = new BufferedReader(new InputStreamReader(new FileInputStream(new File(nomFichero))));
                while ((linea = fichero.readLine()) != null) {
                    if (linea.compareTo("") != 0) {
                        modelo.addLineaCPC(linea);
                    }
                }
            } catch (Exception e) {
                System.err.printf(e.getMessage());
            }

            //Una vez cargado todo el modelo por líneas, lo recorremos para
            //extraer la información de cada una
            Iterator i = modelo.modeloCPC.iterator();
            String cadena;
            while (i.hasNext()) {
                cadena = (String) i.next();
                while (cadena.startsWith("Modelo")) {
                    MEM mod = new MEM();
                    mod.nombre = cadena.replace(":", "");
                    cadena = (String) i.next();
                    while (!cadena.startsWith("Modelo") && !cadena.startsWith("*****")) {
                        Pattern patron = Pattern.compile("(.+) := (.+)\\((.+)\\)");
                        Matcher matcher = patron.matcher(cadena);
                        matcher.find();
                        
                        Interpretacion ec = new Interpretacion();
                        ec.nombre = matcher.group(2);
                        ec.variableCabeza = matcher.group(1);
                        if (!varUsadas.contains(ec.variableCabeza)) {
                            varUsadas.add(ec.variableCabeza);
                        }
                        String palabra[] = matcher.group(3).split(", ");
                        for (int j = 0; j < palabra.length; j++) {
                            ec.addVariableCola(palabra[j]);
                            if (!varUsadas.contains(palabra[j]) && !modelo.variablesEntrada.contains(palabra[j])) {//////////////
                                varUsadas.add(palabra[j]);
                            }
                        }
                        mod.addInterpretacion(ec);
                        cadena = (String) i.next();
                    }
                    modelo.addMEM(mod);
                }
            }
        }
    }

    //Almacena en un fichero de texto los valores generados
    //para cada variable de entrada
    public void guardarFicheroEntradas(ArrayList<String> variables, ArrayList<double[]> valores, String fichero) {
        try {
            BufferedWriter bw = new BufferedWriter(new FileWriter(fichero));
            Iterator i = variables.iterator();
            String linea = (String) i.next();
            while (i.hasNext()) {
                linea = linea + "\t" + (String) i.next();
            }
            bw.write(linea);
            int numVariables = valores.size();
            int numValores = valores.get(0).length;
            for (int n = 0; n < numValores; n++) {
                bw.newLine();
                linea = String.valueOf(valores.get(0)[n]);
                for (int k = 1; k < numVariables; k++) {
                    linea = linea + "\t" + String.valueOf(valores.get(k)[n]);
                }
                bw.write(linea);
            }
            bw.newLine();
            bw.write("end");
            bw.close();
        } catch (IOException io) {
            System.err.printf(io.getMessage());
        }
    }

    //Almacena en un fichero de texto los fallos paramétricos
    //diseñados por el usuario
    public void guardarFicheroFallos(ArrayList<Fallo> fallos, String fichero) {
        try {
            BufferedWriter bw = new BufferedWriter(new FileWriter(fichero));
            String linea = "NumParam" + "\t" + "Tipo" + "\t" + "FailStep" + "\t" + "ErrorMagnitude";
            bw.write(linea);
            Iterator i = fallos.iterator();
            while (i.hasNext()) {
                bw.newLine();
                Fallo f = (Fallo) i.next();
                linea = String.valueOf(f.numParam) + "\t" + f.tipo + "\t" + String.valueOf(f.failStep) + "\t" + String.valueOf(f.errorMagnitude);
                bw.write(linea);
            }
            bw.close();
        } catch (IOException io) {
            System.err.printf(io.getMessage());
        }
    }

    //Almacena en un fichero de texto el resultado de
    //convertir un modelo a notación "Entrada / Salida"
    public void guardarModeloConvertido(ModeloSistema modelo, String fichero) {
        try {
            BufferedWriter bw = new BufferedWriter(new FileWriter(fichero));
            Iterator i = modelo.modeloES.iterator();
            String linea;
            while (i.hasNext()) {
                linea = (String) i.next();
                bw.write(linea);
                bw.newLine();
            }
            bw.close();
        } catch (IOException io) {
            System.err.printf(io.getMessage());
        }
    }

    //Almacena en un fichero de texto los resultados de la
    //generación de un experimento
    public void guardarResultadoExperimento(GeneradorExperimentos exp, String fichero) {
        try {
            BufferedWriter bw = new BufferedWriter(new FileWriter(fichero));
            DefaultTableModel modelo = exp.modeloTabla;
            int columnas = modelo.getColumnCount();
            int filas = modelo.getRowCount();
            String linea = modelo.getColumnName(0);
            for (int i = 1; i < columnas; i++) {
                linea = linea + "\t" + modelo.getColumnName(i);
            }
            bw.write(linea);
            for (int i = 0; i < filas; i++) {
                bw.newLine();
                linea = modelo.getValueAt(i, 0).toString();
                for (int j = 1; j < columnas; j++) {
                    linea = linea + "\t" + modelo.getValueAt(i, j).toString();
                }
                bw.write(linea);
            }
            bw.close();
        } catch (IOException io) {
            System.err.printf(io.getMessage());
        }
    }

    //Almacena en fichero los resultados de la generación de
    //modelos. Cada modelo va a un fichero .sim distinto.
    public void guardarModelosSimulacion(ModeloSistema modelo) {
        JFileChooser fc = new JFileChooser();
        fc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        int respuesta = fc.showSaveDialog(fc);
        
        if (respuesta == JFileChooser.APPROVE_OPTION) {
            File carpeta = fc.getSelectedFile();
            String ruta = carpeta.getAbsolutePath();
            Iterator i = modelo.listaModelosSimulacion.iterator();
            String linea = (String) i.next();

            while (linea.startsWith("Modelo")) {
                String nomFichero = ruta + "\\" + linea;
                System.out.println(nomFichero);
                File fichero = new File(nomFichero);
                try {
                    BufferedWriter bw = new BufferedWriter(new FileWriter(fichero));
                    linea = (String) i.next();
                    while (!linea.startsWith("Modelo")) {
                        bw.write(linea);
                        bw.newLine();
                        if (i.hasNext()) {
                            linea = (String) i.next();
                        } else {
                            break;
                        }
                    }
                    bw.close();
                } catch (IOException io) {
                    System.err.printf(io.getMessage());
                }
            }
        }
    }

    //Almacena en fichero de texto una configuración de experimento
    //creada por el usuario
    public void guardarConfiguracionExperimento(GeneradorExperimentos moduloGE, String fichero) {
        try {
            BufferedWriter bw = new BufferedWriter(new FileWriter(fichero));
            String linea = "Tsim" + "\t" + "DeltaT" + "\t" + "Umbral";
            bw.write(linea);
            bw.newLine();
            linea = String.valueOf(moduloGE.Tsim) + "\t"
                    + String.valueOf(moduloGE.deltaT) + "\t"
                    + String.valueOf(moduloGE.umbral);
            bw.write(linea);
            bw.close();
        } catch (IOException io) {
            System.err.printf(io.getMessage());
        }
    }

    //Carga los parámetros de configuración de un experimento almacenados en fichero de texto
    //Versión automática
    public void cargarConfiguracionExperimento(GeneradorExperimentos exp, String ruta) {
        String nomFichero = ruta;
        String linea;
        try {
            BufferedReader fichero = new BufferedReader(new InputStreamReader(new FileInputStream(new File(nomFichero))));
            linea = fichero.readLine();
            linea = fichero.readLine();
            String[] valores = linea.split("\t");
            exp.setTsim(Integer.parseInt(valores[0]));
            exp.setDeltaT(Double.parseDouble(valores[1]));
            exp.setUmbral(Double.parseDouble(valores[2]));
        } catch (Exception e) {
            System.err.printf(e.getMessage());
        }
    }

    //Carga los parámetros de configuración de un experimento almacenados en fichero de texto
    //Versión manual
    public void cargarConfiguracionExperimento(GeneradorExperimentos exp) {
        FiltroFicheros filtro = new FiltroFicheros("config");
        fc.setSelectedFile(new File(""));
        fc.setDialogTitle("Select the file that contains the experiment configuration");
        fc.setFileFilter(filtro);
        int returnVal = fc.showOpenDialog(fc);
        if (returnVal == JFileChooser.APPROVE_OPTION) {
            String nomFichero = fc.getSelectedFile().getAbsolutePath();
            String linea;
            try {
                BufferedReader fichero = new BufferedReader(new InputStreamReader(new FileInputStream(new File(nomFichero))));
                linea = fichero.readLine();
                linea = fichero.readLine();
                String[] valores = linea.split("\t");
                exp.setTsim(Integer.parseInt(valores[0]));
                exp.setDeltaT(Double.parseDouble(valores[1]));
                exp.setUmbral(Double.parseDouble(valores[2]));
            } catch (Exception e) {
                System.err.printf(e.getMessage());
            }
        }
    }

    //Carga los fallos que se producen en los parámetros
    //Versión automática
    public void cargarFallos(GeneradorExperimentos exp, String ruta) {
        String nomFichero = ruta;
        String linea;
        try {
            BufferedReader fichero = new BufferedReader(new InputStreamReader(new FileInputStream(new File(nomFichero))));
            linea = fichero.readLine();
            while ((linea = fichero.readLine()) != null) {
                String[] valores = linea.split("\t");
                Fallo f = new Fallo(Integer.parseInt(valores[0]));
                f.setTipo((String) valores[1]);
                f.setFailStep(Integer.parseInt(valores[2]));
                f.setErrorMagnitude(Double.parseDouble(valores[3]));
                exp.addFallo(f.clonar());
            }
        } catch (Exception e) {
            System.err.printf(e.getMessage());
        }

    }

    //Carga los fallos que se producen en los parámetros
    //Versión manual
    public void cargarFallos(GeneradorExperimentos exp) {
        FiltroFicheros filtro = new FiltroFicheros("txt");
        fc.setSelectedFile(new File(""));
        fc.setDialogTitle("Select the file that contains the parametric faults");
        fc.setFileFilter(filtro);
        int returnVal = fc.showOpenDialog(fc);
        if (returnVal == JFileChooser.APPROVE_OPTION) {
            String nomFichero = fc.getSelectedFile().getAbsolutePath();
            String linea;
            try {
                BufferedReader fichero = new BufferedReader(new InputStreamReader(new FileInputStream(new File(nomFichero))));
                linea = fichero.readLine();
                while ((linea = fichero.readLine()) != null) {
                    String[] valores = linea.split("\t");
                    Fallo f = new Fallo(Integer.parseInt(valores[0]));
                    f.setTipo((String) valores[1]);
                    f.setFailStep(Integer.parseInt(valores[2]));
                    f.setErrorMagnitude(Double.parseDouble(valores[3]));
                    exp.addFallo(f.clonar());
                }
            } catch (Exception e) {
                System.err.printf(e.getMessage());
            }
        }
    }

    //Carga desde fichero de texto los parámetros del sistema y sus valores
    //Versión automática
    public void cargarParametros(ModeloSistema modelo, String ruta) {
        String nomFichero = ruta;
        String linea;
        try {
            BufferedReader fichero = new BufferedReader(new InputStreamReader(new FileInputStream(new File(nomFichero))));
            linea = fichero.readLine();
            String[] nombres = linea.split("\t");
            linea = fichero.readLine();
            String[] valores = linea.split("\t");
            for (int i = 0; i < nombres.length; i++) {
                modelo.addParametro(new Parametro(nombres[i], Double.parseDouble(valores[i])));
            }
        } catch (Exception e) {
            System.err.printf(e.getMessage());
        }
    }

    //Carga desde fichero de texto los parámetros del sistema y sus valores
    //Versión manual
    public void cargarParametros(ModeloSistema modelo) {
        FiltroFicheros filtro = new FiltroFicheros("txt");
        fc.setSelectedFile(new File(""));
        fc.setDialogTitle("Slect the file that contains the parameters");
        fc.setFileFilter(filtro);
        int returnVal = fc.showOpenDialog(fc);
        if (returnVal == JFileChooser.APPROVE_OPTION) {
            String nomFichero = fc.getSelectedFile().getAbsolutePath();
            String linea;
            try {
                BufferedReader fichero = new BufferedReader(new InputStreamReader(new FileInputStream(new File(nomFichero))));
                linea = fichero.readLine();
                String[] nombres = linea.split("\t");
                linea = fichero.readLine();
                String[] valores = linea.split("\t");
                for (int i = 0; i < nombres.length; i++) {
                    modelo.addParametro(new Parametro(nombres[i], Double.parseDouble(valores[i])));
                }
            } catch (Exception e) {
                System.err.printf(e.getMessage());
            }
        }
    }

    //Carga los valores que van a tomar las variables de entrada durante un experimento
    //Versión automática
    public void cargarValoresEntrada(GeneradorExperimentos exp, String ruta) {
        String nomFichero = ruta;
        String linea;
        try {
            BufferedReader fichero = new BufferedReader(new InputStreamReader(new FileInputStream(new File(nomFichero))));
            linea = fichero.readLine();
            String[] nombres = linea.split("\t");
            ArrayList<Variable> variables = new ArrayList<Variable>();
            Variable e;
            for (int i = 0; i < nombres.length; i++) {
                e = new Variable(nombres[i]);
                variables.add(e);
            }
            String[] valores;
            linea = fichero.readLine();
            while (!linea.startsWith("end")) {
                valores = linea.split("\t");
                double valor;
                for (int i = 0; i < valores.length; i++) {
                    valor = Double.parseDouble(valores[i]);
                    variables.get(i).addValor(valor);
                }
                linea = fichero.readLine();
            }
            for (int i = 0; i < nombres.length; i++) {
                exp.addEntrada(variables.get(i).clonar());
            }
        } catch (Exception ex) {
            System.err.printf(ex.getMessage());
        }
    }

    //Carga los valores que van a tomar las variables de entrada durante un experimento
    //Versión manual
    public void cargarValoresEntrada(GeneradorExperimentos exp) {
        FiltroFicheros filtro = new FiltroFicheros("txt");
        fc.setSelectedFile(new File(""));
        fc.setDialogTitle("Select the file that contain the input values");
        fc.setFileFilter(filtro);
        int returnVal = fc.showOpenDialog(fc);
        if (returnVal == JFileChooser.APPROVE_OPTION) {
            String nomFichero = fc.getSelectedFile().getAbsolutePath();
            String linea;
            try {
                BufferedReader fichero = new BufferedReader(new InputStreamReader(new FileInputStream(new File(nomFichero))));
                linea = fichero.readLine();
                String[] nombres = linea.split("\t");
                ArrayList<Variable> variables = new ArrayList<Variable>();
                Variable e;
                for (int i = 0; i < nombres.length; i++) {
                    e = new Variable(nombres[i]);
                    variables.add(e);
                }
                String[] valores;
                linea = fichero.readLine();

                while (!linea.startsWith("end")) {
                    valores = linea.split("\t");
                    double valor;
                    for (int i = 0; i < valores.length; i++) {
                        valor = Double.parseDouble(valores[i]);
                        variables.get(i).addValor(valor);
                    }
                    linea = fichero.readLine();
                }
                for (int i = 0; i < nombres.length; i++) {
                    exp.addEntrada(variables.get(i).clonar());
                }                
            } catch (Exception ex) {
                System.err.printf(ex.getMessage());
                System.out.println("An error occurred while reading the input values file.");
            }
        }
    }

    //Carga los valores que tienen las variables del sistema en el instante inicial
    //de la ejecución de un experimento. Se almacenan en fichero de texto.
    //Versión automática
    public void cargarCondicionesIniciales(GeneradorExperimentos exp, String ruta) {
        String nomFichero = ruta;
        String linea;
        try {
            BufferedReader fichero = new BufferedReader(new InputStreamReader(new FileInputStream(new File(nomFichero))));
            linea = fichero.readLine();
            String[] nombres = linea.split("\t");
            linea = fichero.readLine();
            String[] valores = linea.split("\t");
            ArrayList<Variable> condicionesIniciales = new ArrayList<Variable>();
            for (int i = 0; i < nombres.length; i++) {
                Variable v = new Variable(nombres[i]);
                v.addValor(Double.parseDouble(valores[i]));
                condicionesIniciales.add(v.clonar());
            }
            Iterator it = condicionesIniciales.iterator();
            while (it.hasNext()) {
                Variable v = (Variable) it.next();
                exp.condicionesIniciales.add(v.clonar());
            }
        } catch (Exception ex) {
            System.err.printf(ex.getMessage());
        }
    }

    //Carga los valores que tienen las variables del sistema en el instante inicial
    //de la ejecución de un experimento. Se almacenan en fichero de texto.
    //Versión manual
    public void cargarCondicionesIniciales(GeneradorExperimentos exp) {
        FiltroFicheros filtro = new FiltroFicheros("txt");
        fc.setSelectedFile(new File(""));
        fc.setDialogTitle("Select the file that contains the initial conditions");
        fc.setFileFilter(filtro);
        int returnVal = fc.showOpenDialog(fc);
        if (returnVal == JFileChooser.APPROVE_OPTION) {
            String nomFichero = fc.getSelectedFile().getAbsolutePath();
            String linea;
            try {
                BufferedReader fichero = new BufferedReader(new InputStreamReader(new FileInputStream(new File(nomFichero))));
                linea = fichero.readLine();
                String[] nombres = linea.split("\t");
                linea = fichero.readLine();
                String[] valores = linea.split("\t");
                ArrayList<Variable> condicionesIniciales = new ArrayList<Variable>();
                for (int i = 0; i < nombres.length; i++) {
                    Variable v = new Variable(nombres[i]);
                    v.addValor(Double.parseDouble(valores[i]));
                    condicionesIniciales.add(v.clonar());
                }
                Iterator it = condicionesIniciales.iterator();
                while (it.hasNext()) {
                    Variable v = (Variable) it.next();
                    exp.condicionesIniciales.add(v.clonar());
                }
            } catch (Exception ex) {
                System.err.printf(ex.getMessage());
            }
        }
    }

    public void cargarModSim(ModeloSistema modelo, String ruta) {
        File f = new File(ruta);
        File[] ficheros = f.listFiles(new Filtro("sim"));
        String nomFichero;
        String nomModelo;
        for (int i = 0; i < ficheros.length; i++) {
            nomFichero = ficheros[i].getAbsolutePath();
            nomModelo = ficheros[i].getName().replace("Simulacion.sim", "");
            String linea;
            try {
                BufferedReader fichero = new BufferedReader(new InputStreamReader(new FileInputStream(new File(nomFichero))));
                ModeloSimulacion modSim = new ModeloSimulacion(nomModelo, nomFichero, modelo);
                while ((linea = fichero.readLine()) != null) {
                    modSim.addEcuacion(linea);
                }
                modSim.initVariables();
                modSim.findNodoDiscrepancia();
                modelo.addModSim(modSim);
            } catch (Exception ex) {
                ex.printStackTrace();
            }
        }

    }

    public void cargarModSim(ModeloSistema modelo) {
        FiltroFicheros filtro = new FiltroFicheros("sim");
        fc.setMultiSelectionEnabled(true);
        fc.setSelectedFile(new File(""));
        fc.setDialogTitle("Select all the simulation models you want to use");
        fc.setFileFilter(filtro);
        int returnVal = fc.showOpenDialog(fc);
        if (returnVal == JFileChooser.APPROVE_OPTION) {
            File[] ficheros = fc.getSelectedFiles();
            String nomFichero;
            String nomModelo;
            for (int i = 0; i < ficheros.length; i++) {
                nomFichero = ficheros[i].getAbsolutePath();
                nomModelo = ficheros[i].getName().replace("Simulacion.sim", "");
                String linea;
                try {
                    BufferedReader fichero = new BufferedReader(new InputStreamReader(new FileInputStream(new File(nomFichero))));
                    ModeloSimulacion modSim = new ModeloSimulacion(nomModelo, nomFichero, modelo);
                    while ((linea = fichero.readLine()) != null) {
                        modSim.addEcuacion(linea);
                    }
                    modSim.initVariables();
                    modSim.findNodoDiscrepancia();
                    modelo.addModSim(modSim);
                } catch (Exception ex) {
                    ex.printStackTrace();
                }
            }
        }
    }

    public void cargarExperimento(GeneradorExperimentos moduloGE, String ruta) {
        String nomFichero = ruta;
        String linea;
        try {
            DefaultTableModel modeloTabla = new DefaultTableModel();
            BufferedReader fichero = new BufferedReader(new InputStreamReader(new FileInputStream(new File(nomFichero))));
            linea = fichero.readLine();
            String[] nombres = linea.split("\t");
            for (int i = 0; i < nombres.length; i++) {
                modeloTabla.addColumn(nombres[i]);
            }
            while ((linea = fichero.readLine()) != null) {
                Object[] valores = linea.split("\t");
                modeloTabla.addRow(valores);
            }
            moduloGE.setModeloTabla(modeloTabla);
        } catch (Exception ex) {
            System.err.printf(ex.getMessage());
        }
    }

    public void cargarExperimento(GeneradorExperimentos moduloGE) {
        FiltroFicheros filtro = new FiltroFicheros("txt");
        fc.setSelectedFile(new File(""));
        fc.setDialogTitle("Select the file that contains the experiment results");
        fc.setFileFilter(filtro);
        int returnVal = fc.showOpenDialog(fc);
        if (returnVal == JFileChooser.APPROVE_OPTION) {
            String nomFichero = fc.getSelectedFile().getAbsolutePath();
            String linea;
            try {
                DefaultTableModel modeloTabla = new DefaultTableModel();
                BufferedReader fichero = new BufferedReader(new InputStreamReader(new FileInputStream(new File(nomFichero))));
                linea = fichero.readLine();
                String[] nombres = linea.split("\t");
                for (int i = 0; i < nombres.length; i++) {
                    modeloTabla.addColumn(nombres[i]);
                }
                while ((linea = fichero.readLine()) != null) {
                    Object[] valores = linea.split("\t");
                    modeloTabla.addRow(valores);
                }
                moduloGE.setModeloTabla(modeloTabla);
            } catch (Exception ex) {
                System.err.printf(ex.getMessage());
            }
        }
    }

    public void cargarSistemaXML(Interfaz ventana, Diagnosis moduloDX) throws ParserConfigurationException, SAXException, IOException {
        File filePath = null;
        // Se solicita el fichero XML de definición de PCs mediante un cuadro de diálogo.
        // Sólo se consideran los ficheros con extensión '.xml'.
        // Si se hace clic en el botón 'Cancelar', no se hace nada.
        JFileChooser fch = new JFileChooser();
        fch.setDialogTitle("Select the XML file that contains the PC definitions");
        fch.setDialogType(JFileChooser.OPEN_DIALOG);
        fch.setFileSelectionMode(JFileChooser.FILES_ONLY);
        if (filePath != null) {
            fch.setCurrentDirectory(filePath);
        }
        FileNameExtensionFilter filter = new FileNameExtensionFilter("XML files", "xml");
        fch.setFileFilter(filter);
        int returnVal = fch.showOpenDialog(ventana);
        if (returnVal != JFileChooser.APPROVE_OPTION) {
            return; // Se ha cancelado la selección del fichero.
        }
        String fileName = fch.getSelectedFile().getName();
        String filePathAndName = fch.getSelectedFile().getAbsolutePath();
        filePath = new File(fch.getSelectedFile().getAbsolutePath());

        // Se comprueba que el fichero XML especificado exista y se pueda leer.
        // Si no existe o no se puede leer, se muestra el mensaje de error correspondiente y no se hace nada.
        File file = new File(filePathAndName);
        if (!file.exists() || !file.canRead()) {
            JOptionPane.showMessageDialog(ventana,
                    "File '" + fileName + "' does not exist or cannot be read.",
                    "Warning",
                    JOptionPane.WARNING_MESSAGE);
            return;
        }

        // Se hace el 'parse' del fichero XML y se almacena el DOM en memoria.
        // Si el fichero no es correcto sintácticamente, se muestra el mensaje de error correspondiente y no se hace nada.
        DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
        dbf.setIgnoringComments(true);
        DocumentBuilder db = dbf.newDocumentBuilder();
        try {
            moduloDX.docXML = db.parse(file);
        } catch (Exception e) {
            // Las excepciones posibles son:
            //  org.xml.sax.SAXException, si hay un error de análisis.
            //  java.io.IOException, si hay un error de lectura del fichero (que aquí no es esperado).
            JOptionPane.showMessageDialog(ventana,
                    "In '" + fileName + "': " + e.getMessage(),
                    "XML Error Warning",
                    JOptionPane.WARNING_MESSAGE);
            return;
        }

        // Si no hay errores de análisis y el fichero es de tipo RESULTADOS, se
        // cambia el título de la ventana y se carga el sistema en las
        // estructuras de memoria adecuadas.
        moduloDX.docXML.getDocumentElement().normalize();
        if (!moduloDX.docXML.getDocumentElement().getNodeName().equals("RESULTADOS")) {
            JOptionPane.showMessageDialog(ventana,
                    "File '" + fileName + "' is not a valid file. Please select a 'RESULTADOS' xml file, generated by PCs tool.",
                    "Warning",
                    JOptionPane.WARNING_MESSAGE);
            return;
        }
        moduloDX.cargaSistema();
    }

    public void guardarResultadoDiagnosis(Interfaz ventana, String fichero) {
        try {
            BufferedWriter bw = new BufferedWriter(new FileWriter(fichero));
            String linea = ventana.textoResultadoDX.getText();
            bw.write(linea);
            bw.close();
        } catch (IOException io) {
            System.err.println(io.getMessage());
        }
    }

    public class Filtro implements FilenameFilter {
        String extension;
        Filtro(String extension) {
            this.extension = extension;
        }
        public boolean accept(File dir, String name) {
            return name.endsWith(extension);
        }
    }
}
