/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package generadorexperimentosdiagnosis;

import java.awt.*;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Iterator;
import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JTabbedPane;
import javax.swing.JTable;
import javax.swing.JTextPane;
import javax.swing.SwingConstants;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableCellRenderer;
import javax.swing.text.BadLocationException;
import javax.swing.text.SimpleAttributeSet;
import javax.swing.text.StyleConstants;
import javax.swing.text.StyledDocument;

/**
 *
 * @author David Rubio + Luis Miguel Villarroel
 */
//Interfaz principal de la aplicación
public class Interfaz extends JFrame {

    Control padre;
    JTabbedPane panelPestanas;
    
    //Componentes del menú
    JMenuBar menu = new JMenuBar();
    JMenu menuArchivo = new JMenu();
    JMenu menuVentana = new JMenu();
    JMenu menuAyuda = new JMenu();
    JMenuItem archivoEntradas = new JMenuItem();
    JMenuItem archivoFallos = new JMenuItem();
    JMenuItem archivoSalir = new JMenuItem();
    JMenuItem ventanaPanelCM = new JMenuItem();
    JMenuItem ventanaPanelGE = new JMenuItem();
    JMenuItem ventanaPanelGMS = new JMenuItem();
    JMenuItem ventanaPanelDX = new JMenuItem();
    JMenuItem contenidos = new JMenuItem();
    JMenuItem acercaDe = new JMenuItem();
    
    //Componentes del panel de conversor de modelos
    JButton cargarModeloCM = new JButton();
    JButton convertir = new JButton();
    JButton guardarMod = new JButton();
    JTextPane textoCM = new JTextPane();
    JTextPane textoResultadoCM = new JTextPane();
    
    //Componentes del panel del generador de experimentos
    JButton cargarModeloGE = new JButton();
    JButton generarExp = new JButton();
    JButton verGrafico = new JButton();
    JButton guardarExp = new JButton();
    JTextPane textoExp = new JTextPane();
    JTable tablaExperimento = new JTable();
    
    //Componentes del panel del generador de modelos de simulación
    JButton cargarModeloGMS = new JButton();
    JButton generarModSim = new JButton();
    JButton guardarModSim = new JButton();
    JTextPane textoModSim = new JTextPane();
    JTextPane textoPC = new JTextPane();
    JTextPane textoResultadoModSim = new JTextPane();
    
    //Componentes del panel de diagnosis
    JButton cargarModeloDX = new JButton();
    JButton calcularResiduos = new JButton();
    JButton calcularCandidatos = new JButton();
    JButton guardarDX = new JButton();
    JButton verGraficoDX = new JButton();
    JTextPane textoDX = new JTextPane();
    JTextPane textoResultadoDX = new JTextPane();
    JTable tablaExpDX = new JTable();
    JTable tablaResiduos = new JTable();

    //Método de creación
    public Interfaz(Control c) {
        this.padre = c;
        try {
            setDefaultCloseOperation(EXIT_ON_CLOSE);
            jbInit();
        } catch (Exception e) {
        }
    }

    //Método de inicialización
    private void jbInit() throws Exception {
        setSize(new Dimension(1024, 768));
        setTitle("Diagnosis Experiment Generator");

        //Inicialización del menú
        this.setJMenuBar(menu);
        menuArchivo.setText("File");
        menuVentana.setText("Window");
        menuAyuda.setText("Help");
        archivoEntradas.setText("Generate inputs file");
        archivoEntradas.setActionCommand("Entradas");
        archivoEntradas.addActionListener(padre);
        archivoFallos.setText("Generate parametric faults file");
        archivoFallos.setActionCommand("Fallos");
        archivoFallos.addActionListener(padre);
        archivoSalir.setText("Exit");
        archivoSalir.setActionCommand("Salir");
        archivoSalir.addActionListener(padre);
        ventanaPanelCM.setText("SS / IO notation converter");
        ventanaPanelCM.setActionCommand("Abrir panel CM");
        ventanaPanelCM.addActionListener(padre);
        ventanaPanelGE.setText("Experiment generator");
        ventanaPanelGE.setActionCommand("Abrir panel GE");
        ventanaPanelGE.addActionListener(padre);
        ventanaPanelGMS.setText("Model Simulation generator");
        ventanaPanelGMS.setActionCommand("Abrir panel GMS");
        ventanaPanelGMS.addActionListener(padre);
        ventanaPanelDX.setText("Diagnosis");
        ventanaPanelDX.setActionCommand("Abrir panel DX");
        ventanaPanelDX.addActionListener(padre);
        contenidos.setText("Contents");
        contenidos.setActionCommand("Contenidos");
        contenidos.addActionListener(padre);
        acercaDe.setText("About");
        acercaDe.setActionCommand("Acerca de");
        acercaDe.addActionListener(padre);
        menuArchivo.add(archivoEntradas);
        menuArchivo.add(archivoFallos);
        menuArchivo.addSeparator();
        menuArchivo.add(archivoSalir);
        menuVentana.add(ventanaPanelCM);
        menuVentana.add(ventanaPanelGE);
        menuVentana.add(ventanaPanelGMS);
        menuVentana.add(ventanaPanelDX);
        menuAyuda.add(contenidos);
        menuAyuda.add(acercaDe);
        menu.add(menuArchivo);
        menu.add(menuVentana);
        menu.add(menuAyuda);

        //Inicialización de los paneles
        panelPestanas = new JTabbedPane();
        this.add(panelPestanas, java.awt.BorderLayout.CENTER);
        setPanelCM();
        setPanelGE();
        setPanelGMS();
        setPanelDX();
    }

    //Función que dispone e inicializa los compoenentes del
    //panel del conversor de modelos
    private void setPanelCM() {
        JSplitPane jSplitPaneCM = new JSplitPane();
        jSplitPaneCM.setDividerLocation(330);

        cargarModeloCM.setActionCommand("Cargar Modelo CM");
        cargarModeloCM.setText("Load Model");
        cargarModeloCM.addActionListener(padre);
        convertir.setActionCommand("convertir");
        convertir.setText("Convert Model");
        convertir.addActionListener(padre);
        guardarMod.setActionCommand("GuardarModES");
        guardarMod.setText("Save");
        guardarMod.addActionListener(padre);
        
        JPanel panelBotones = new JPanel();
        panelBotones.setBorder(BorderFactory.createTitledBorder("Options"));
        panelBotones.add(cargarModeloCM);
        panelBotones.add(convertir);
        panelBotones.add(guardarMod);
        panelBotones.setMinimumSize(new Dimension(300, 100));
        panelBotones.setPreferredSize(new Dimension(300, 100));
        panelBotones.setMaximumSize(new Dimension(300, 100));

        JPanel panelTexto = new JPanel();
        panelTexto.setBorder(BorderFactory.createTitledBorder("System Model"));
        panelTexto.setLayout(new BoxLayout(panelTexto, BoxLayout.PAGE_AXIS));

        textoCM.setEditable(false);
        textoCM.setFocusable(false);
        StyledDocument styledDoc = textoCM.getStyledDocument();
        SimpleAttributeSet atributos = new SimpleAttributeSet();
        try {
            styledDoc.insertString(styledDoc.getLength(), "\n  System Model visualization field\n\n", atributos);
            styledDoc.insertString(styledDoc.getLength(), "  Load system model by selecting the appropriate option\n", atributos);
        } catch (BadLocationException ble) {
            System.err.println("Error while inserting instructions in the panel");
        }
        textoCM.moveCaretPosition(0);

        JScrollPane scrollTextoCM = new JScrollPane(textoCM);
        scrollTextoCM.setPreferredSize(new Dimension(300, 175));
        panelTexto.add(scrollTextoCM, java.awt.BorderLayout.CENTER);

        JPanel panelSistema = new JPanel();
        panelSistema.setLayout(new BoxLayout(panelSistema, BoxLayout.PAGE_AXIS));
        panelSistema.add(panelBotones);
        panelSistema.add(panelTexto);
        jSplitPaneCM.add(panelSistema, JSplitPane.LEFT);

        textoResultadoCM.setBorder(BorderFactory.createTitledBorder("Input - Output Notation Model"));
        textoResultadoCM.setEditable(false);
        textoResultadoCM.setFocusable(false);
        StyledDocument styledDoc3 = textoResultadoCM.getStyledDocument();
        SimpleAttributeSet atributos3 = new SimpleAttributeSet();
        try {
            styledDoc3.insertString(styledDoc3.getLength(), "\n  Results display field \n\n", atributos3);
            styledDoc3.insertString(styledDoc3.getLength(), "  Generate IO model by selecting the appropriate option\n", atributos3);
        } catch (BadLocationException ble) {
            System.err.println("Error while inserting instructions in the panel");
        }
        textoResultadoCM.moveCaretPosition(0);
        JScrollPane scrollTextoResultadoCM = new JScrollPane(textoResultadoCM);
        jSplitPaneCM.add(scrollTextoResultadoCM, JSplitPane.RIGHT);
        panelPestanas.add(jSplitPaneCM, "SS / IO Notation converter");
    }

    //Función que dispone e inicializa los compoenentes del
    //panel del generador de experimentos
    private void setPanelGE() {
        JSplitPane jSplitPaneGE = new JSplitPane();
        jSplitPaneGE.setDividerLocation(300);
        
        cargarModeloGE.setActionCommand("Cargar Modelo GE");
        cargarModeloGE.setText("Load Model");
        cargarModeloGE.addActionListener(padre);
        generarExp.setActionCommand("GenerarExp");
        generarExp.setText("Generate Experiment");
        generarExp.addActionListener(padre);
        verGrafico.setActionCommand("VerGrafico");
        verGrafico.setText("Display Graph");
        verGrafico.addActionListener(padre);
        guardarExp.setActionCommand("GuardarExp");
        guardarExp.setText("Save");
        guardarExp.addActionListener(padre);
        
        JPanel panelBotones = new JPanel();
        panelBotones.setBorder(BorderFactory.createTitledBorder("Options"));
        panelBotones.add(cargarModeloGE);
        panelBotones.add(generarExp);
        panelBotones.add(verGrafico);
        panelBotones.add(guardarExp);
        panelBotones.setMinimumSize(new Dimension(300, 100));
        panelBotones.setPreferredSize(new Dimension(300, 100));
        panelBotones.setMaximumSize(new Dimension(300, 100));

        JPanel panelTexto = new JPanel();
        panelTexto.setBorder(BorderFactory.createTitledBorder("System Model"));
        panelTexto.setLayout(new BoxLayout(panelTexto, BoxLayout.PAGE_AXIS));

        textoExp.setEditable(false);
        textoExp.setFocusable(false);
        StyledDocument styledDoc = textoExp.getStyledDocument();
        SimpleAttributeSet atributos = new SimpleAttributeSet();
        try {
            styledDoc.insertString(styledDoc.getLength(), "\n  System display field\n\n", atributos);
            styledDoc.insertString(styledDoc.getLength(), "  Load system model by selecting the appropriate option\n", atributos);
        } catch (BadLocationException ble) {
            System.err.println("Error while inserting instructions in the panel");
        }
        textoExp.moveCaretPosition(0);

        JScrollPane scrollTextoExp = new JScrollPane(textoExp);
        scrollTextoExp.setPreferredSize(new Dimension(300, 175));
        panelTexto.add(scrollTextoExp, java.awt.BorderLayout.CENTER);

        JPanel panelSistema = new JPanel();
        panelSistema.setLayout(new BoxLayout(panelSistema, BoxLayout.PAGE_AXIS));
        panelSistema.add(panelBotones);
        panelSistema.add(panelTexto);
        jSplitPaneGE.add(panelSistema, JSplitPane.LEFT);

        JPanel panelResultados = new JPanel();
        panelResultados.setLayout(new BorderLayout());
        panelResultados.setBorder(BorderFactory.createTitledBorder("Results"));
        JScrollPane scrollTablaExperimento = new JScrollPane(tablaExperimento);
        panelResultados.add(scrollTablaExperimento);
        jSplitPaneGE.add(panelResultados, JSplitPane.RIGHT);
        panelPestanas.add(jSplitPaneGE, "Experiment Generator");
    }

    //Función que dispone e inicializa los componentes del
    //panel del generador de modelos de simulación
    private void setPanelGMS() {
        JSplitPane jSplitPane1 = new JSplitPane();
        jSplitPane1.setDividerLocation(300);
        
        cargarModeloGMS.setActionCommand("Cargar Modelo GMS");
        cargarModeloGMS.setText("Load Model");
        cargarModeloGMS.addActionListener(padre);
        generarModSim.setActionCommand("GenerarSim");
        generarModSim.setText("Generate (Simulation)");
        generarModSim.addActionListener(padre);
        guardarModSim.setActionCommand("GuardarModSim");
        guardarModSim.setText("Save");
        guardarModSim.addActionListener(padre);
        
        JPanel panelBotones = new JPanel();
        panelBotones.setBorder(BorderFactory.createTitledBorder("Options"));
        panelBotones.add(cargarModeloGMS);
        panelBotones.add(generarModSim);
        panelBotones.add(guardarModSim);
        panelBotones.setMinimumSize(new Dimension(300, 100));
        panelBotones.setPreferredSize(new Dimension(300, 100));
        panelBotones.setMaximumSize(new Dimension(300, 100));

        JPanel panelTexto = new JPanel();
        panelTexto.setBorder(BorderFactory.createTitledBorder("System Model"));
        panelTexto.setLayout(new BoxLayout(panelTexto, BoxLayout.PAGE_AXIS));

        textoModSim.setEditable(false);
        textoModSim.setFocusable(false);
        StyledDocument styledDoc = textoModSim.getStyledDocument();
        SimpleAttributeSet atributos = new SimpleAttributeSet();
        try {
            styledDoc.insertString(styledDoc.getLength(), "\n  System display field\n\n", atributos);
            styledDoc.insertString(styledDoc.getLength(), "  Load system model by selecting the appropriate option\n", atributos);
        } catch (BadLocationException ble) {
            System.err.println("Error while inserting instructions in the panel");
        }
        textoModSim.moveCaretPosition(0);

        textoPC.setEditable(false);
        textoPC.setFocusable(false);
        StyledDocument styledDoc2 = textoPC.getStyledDocument();
        SimpleAttributeSet atributos2 = new SimpleAttributeSet();
        try {
            styledDoc2.insertString(styledDoc2.getLength(), "\n  System display field\n\n", atributos2);
            styledDoc2.insertString(styledDoc2.getLength(), "  Load results from PC calculation by selecting the appropriate option\n", atributos2);
        } catch (BadLocationException ble) {
            System.err.println("Error while inserting instructions in the panel");
        }
        textoPC.moveCaretPosition(0);

        JScrollPane scrollTextoModSim = new JScrollPane(textoModSim);
        scrollTextoModSim.setPreferredSize(new Dimension(300, 175));
        panelTexto.add(scrollTextoModSim, java.awt.BorderLayout.CENTER);

        JScrollPane scrollTextoPC = new JScrollPane(textoPC);
        scrollTextoPC.setPreferredSize(new Dimension(300, 175));
        panelTexto.add(scrollTextoPC, java.awt.BorderLayout.CENTER);

        JPanel panelSistema = new JPanel();
        panelSistema.setLayout(new BoxLayout(panelSistema, BoxLayout.PAGE_AXIS));
        panelSistema.add(panelBotones);
        panelSistema.add(panelTexto);
        jSplitPane1.add(panelSistema, JSplitPane.LEFT);
        textoResultadoModSim.setBorder(BorderFactory.createTitledBorder("Final Simulation Model"));
        textoResultadoModSim.setEditable(false);
        textoResultadoModSim.setFocusable(false);
        StyledDocument styledDoc3 = textoResultadoModSim.getStyledDocument();
        SimpleAttributeSet atributos3 = new SimpleAttributeSet();
        try {
            styledDoc3.insertString(styledDoc3.getLength(), "\n  Results display field\n\n", atributos3);
            styledDoc3.insertString(styledDoc3.getLength(), "  Generate simulation models by selecting the appropriate option\n", atributos3);
        } catch (BadLocationException ble) {
            System.err.println("Error while inserting instructions in the panel");
        }
        textoResultadoModSim.moveCaretPosition(0);
        JScrollPane scrollTextoResultadoModSim = new JScrollPane(textoResultadoModSim);
        jSplitPane1.add(scrollTextoResultadoModSim, JSplitPane.RIGHT);
        panelPestanas.add(jSplitPane1, "Simulation Model Generator");
    }

    private void setPanelDX() {
        JSplitPane jSplitPaneDX = new JSplitPane();
        jSplitPaneDX.setDividerLocation(300);

        cargarModeloDX.setActionCommand("Cargar Modelo DX");
        cargarModeloDX.setText("Load Model");
        cargarModeloDX.addActionListener(padre);
        calcularResiduos.setActionCommand("Calcular Residuos");
        calcularResiduos.setText("Calculate Residuals");
        calcularResiduos.addActionListener(padre);
        calcularCandidatos.setActionCommand("Calcular Candidatos");
        calcularCandidatos.setText("Fault Candidates Calculation");
        calcularCandidatos.addActionListener(padre);
        guardarDX.setActionCommand("GuardarDX");
        guardarDX.setText("Save Results");
        guardarDX.addActionListener(padre);
        
        JPanel panelBotones = new JPanel();
        panelBotones.setBorder(BorderFactory.createTitledBorder("Options"));
        panelBotones.add(cargarModeloDX);
        panelBotones.add(calcularResiduos);
        panelBotones.add(calcularCandidatos);
        panelBotones.add(guardarDX);

        panelBotones.setMinimumSize(new Dimension(300, 100));
        panelBotones.setPreferredSize(new Dimension(300, 100));
        panelBotones.setMaximumSize(new Dimension(300, 100));

        JPanel panelTexto = new JPanel();
        panelTexto.setBorder(BorderFactory.createTitledBorder("System Model"));
        panelTexto.setLayout(new BoxLayout(panelTexto, BoxLayout.PAGE_AXIS));

        textoDX.setEditable(false);
        textoDX.setFocusable(false);
        StyledDocument styledDoc = textoDX.getStyledDocument();
        SimpleAttributeSet atributos = new SimpleAttributeSet();
        try {
            styledDoc.insertString(styledDoc.getLength(), "\n  System display field\n\n", atributos);
            styledDoc.insertString(styledDoc.getLength(), "  Load system model by selecting the appropriate option\n", atributos);
        } catch (BadLocationException ble) {
            System.err.println("Error while inserting instructions in the panel");
        }
        textoDX.moveCaretPosition(0);

        JScrollPane scrollTextoDX = new JScrollPane(textoDX);
        scrollTextoDX.setPreferredSize(new Dimension(300, 375));
        panelTexto.add(scrollTextoDX, java.awt.BorderLayout.CENTER);

        JPanel panelTablaExp = new JPanel();
        panelTablaExp.setLayout(new BorderLayout());
        panelTablaExp.setBorder(BorderFactory.createTitledBorder("Experiment"));
        JScrollPane scrollTablaExperimento = new JScrollPane(tablaExpDX);
        panelTablaExp.add(scrollTablaExperimento);

        JPanel panelSistema = new JPanel();
        panelSistema.setLayout(new BoxLayout(panelSistema, BoxLayout.PAGE_AXIS));
        panelSistema.add(panelBotones);
        panelSistema.add(panelTexto);
        panelSistema.add(panelTablaExp);
        jSplitPaneDX.add(panelSistema, JSplitPane.LEFT);

        JPanel panelTablaResiduos = new JPanel();
        panelTablaResiduos.setLayout(new BorderLayout());
        panelTablaResiduos.setBorder(BorderFactory.createTitledBorder("Residuals"));
        JScrollPane scrollTablaResiduos = new JScrollPane(tablaResiduos);
        panelTablaResiduos.add(scrollTablaResiduos);

        JPanel panelCandidatos = new JPanel();
        panelCandidatos.setBorder(BorderFactory.createTitledBorder("Fault Candidates"));
        panelCandidatos.setLayout(new BoxLayout(panelCandidatos, BoxLayout.PAGE_AXIS));

        textoResultadoDX.setEditable(false);
        textoResultadoDX.setFocusable(false);
        styledDoc = textoResultadoDX.getStyledDocument();
        atributos = new SimpleAttributeSet();
        try {
            styledDoc.insertString(styledDoc.getLength(), "\n  Candidate display field\n\n", atributos);
            styledDoc.insertString(styledDoc.getLength(), "  Calculate candidates by selecting the appropriate option\n", atributos);
        } catch (BadLocationException ble) {
            System.err.println("Text couldn't be inserted in panel");
        }
        textoResultadoDX.moveCaretPosition(0);

        JScrollPane scrollTextoResultadoDX = new JScrollPane(textoResultadoDX);
        scrollTextoResultadoDX.setPreferredSize(new Dimension(300, 400));
        panelCandidatos.add(scrollTextoResultadoDX, java.awt.BorderLayout.CENTER);

        JPanel panelResultados = new JPanel();
        panelResultados.setLayout(new BoxLayout(panelResultados, BoxLayout.PAGE_AXIS));
        panelResultados.setBorder(BorderFactory.createTitledBorder("Diagnosis Results"));
        verGraficoDX.setActionCommand("GraficoDX");
        verGraficoDX.setText("Display Graph");
        verGraficoDX.addActionListener(padre);
        verGraficoDX.setVisible(false);
        panelResultados.add(verGraficoDX);
        panelResultados.add(panelTablaResiduos);
        panelResultados.add(panelCandidatos);
        jSplitPaneDX.add(panelResultados, JSplitPane.RIGHT);
        panelPestanas.add(jSplitPaneDX, "Diagnosis");
    }

    //Muestra las ecuaciones y variables del modelo
    //en el panel del conversor de modelos
    public void imprimeModeloPanelCM(ModeloSistema modelo) {
        textoCM.setText("");
        StyledDocument styledDoc = textoCM.getStyledDocument();
        SimpleAttributeSet atributos = new SimpleAttributeSet();
        try {
            styledDoc.insertString(styledDoc.getLength(), "\nSystem Model: " + modelo.nombre + "\n", atributos);
            styledDoc.insertString(styledDoc.getLength(), "\nSystem Inputs (X, Y, U, Theta):\n", atributos);
            Iterator i = modelo.listaVariables.iterator();
            while (i.hasNext()) {
                styledDoc.insertString(styledDoc.getLength(), "    " + i.next() + "\n", atributos);
            }
            
            styledDoc.insertString(styledDoc.getLength(), "\nSystem Equations (ODEs):\n", atributos);
            i = modelo.listaEcuaciones.iterator();
            while (i.hasNext()) {
                styledDoc.insertString(styledDoc.getLength(), "    " + i.next() + "\n", atributos);
            }
        } catch (BadLocationException ble) {
            System.err.println("Error while inserting instructions in the panel");
        }
        textoCM.moveCaretPosition(0);
    }

    //Muestra el modelo en notación Entrada / Salida
    //que se ha obtenido tras la conversión
    public void imprimeModESPanelCM(ArrayList<String> modelo) {
        textoResultadoCM.setText("");
        StyledDocument styledDoc = textoResultadoCM.getStyledDocument();
        SimpleAttributeSet atributos = new SimpleAttributeSet();
        try {
            StyleConstants.setBold(atributos, true);
            StyleConstants.setFontSize(atributos, 14);
            Iterator i = modelo.iterator();
            while (i.hasNext()) {
                String linea = (String) i.next();
                styledDoc.insertString(styledDoc.getLength(), linea + "\n", atributos);
            }
        } catch (BadLocationException ble) {
            System.err.println("Error while inserting instructions in the panel");
        }
    }

    //Muestra las ecuaciones y variables del modelo
    //en el panel del generador de experimentos
    public void imprimeModeloPanelGE(ModeloSistema modelo) {
        textoExp.setText("");
        StyledDocument styledDoc = textoExp.getStyledDocument();
        SimpleAttributeSet atributos = new SimpleAttributeSet();
        try {
            styledDoc.insertString(styledDoc.getLength(), "\nSystem Model: " + modelo.nombre + "\n", atributos);
            styledDoc.insertString(styledDoc.getLength(), "\nSystem Inputs (X, Y, U, Theta):\n", atributos);
            Iterator i = modelo.listaVariables.iterator();
            while (i.hasNext()) {
                styledDoc.insertString(styledDoc.getLength(), "    " + i.next() + "\n", atributos);
            }
            styledDoc.insertString(styledDoc.getLength(), "\nSystem Equations (ODEs):\n", atributos);
            i = modelo.listaEcuaciones.iterator();
            while (i.hasNext()) {
                styledDoc.insertString(styledDoc.getLength(), "    " + i.next() + "\n", atributos);
            }
        } catch (BadLocationException ble) {
            System.err.println("Error while inserting instructions in the panel");
        }
        textoExp.moveCaretPosition(0);
    }

    //Representa en el panel del G.E. la tabla con los
    //resultados de un experimento
    public void imprimeTablaExperimento(DefaultTableModel modelo) {
        tablaExperimento.setModel(modelo);
        tablaExperimento.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
        DefaultTableCellRenderer tcr = new DefaultTableCellRenderer();
        tcr.setHorizontalAlignment(SwingConstants.CENTER);
        for (int i = 0; i < modelo.getColumnCount(); i++) {
            tablaExperimento.getColumnModel().getColumn(i).setCellRenderer(tcr);
        }
        //Centramos los headers, necesario si usamos el Look & Feel del sistema
        TableCellRenderer rendererFromHeader = tablaExperimento.getTableHeader().getDefaultRenderer();
        JLabel headerLabel = (JLabel) rendererFromHeader;
        headerLabel.setHorizontalAlignment(JLabel.CENTER);
        tablaExperimento.setVisible(true);
        tablaExperimento.setEnabled(false);

    }

    //Muestra las ecuaciones y variables del modelo
    //en el panel del generador de modelos de simulación
    public void imprimeModeloPanelGMS(ModeloSistema modelo) {
        textoModSim.setText("");
        StyledDocument styledDoc = textoModSim.getStyledDocument();
        SimpleAttributeSet atributos = new SimpleAttributeSet();
        try {
            styledDoc.insertString(styledDoc.getLength(), "\nSystem Model: " + modelo.nombre + "\n", atributos);
            styledDoc.insertString(styledDoc.getLength(), "\nSystem Inputs (X, Y, U, Theta):\n", atributos);
            Iterator i = modelo.listaVariables.iterator();
            while (i.hasNext()) {
                styledDoc.insertString(styledDoc.getLength(), "    " + i.next() + "\n", atributos);
            }

            styledDoc.insertString(styledDoc.getLength(), "\nSystem Equations (ODEs):\n", atributos);
            i = modelo.listaEcuaciones.iterator();
            while (i.hasNext()) {
                styledDoc.insertString(styledDoc.getLength(), "    " + i.next() + "\n", atributos);
            }
        } catch (BadLocationException ble) {
            System.err.println("Error while inserting instructions in the panel");
        }
        textoModSim.moveCaretPosition(0);
    }

    //Muestra las CEMs y los MEMs resultantes del cálculo
    //del conjunto de posibles conflictos
    public void imprimeCPCPanelGMS(ModeloSistema modelo) {
        textoPC.setText("");
        StyledDocument styledDoc = textoPC.getStyledDocument();
        SimpleAttributeSet atributos = new SimpleAttributeSet();
        try {
            Iterator i = modelo.modeloCPC.iterator();
            String linea;
            while (i.hasNext()) {
                linea = (String) i.next();
                if (linea.charAt(0) == '*') {
                    styledDoc.insertString(styledDoc.getLength(), "\n" + linea + "\n", atributos);
                } else {
                    if (linea.startsWith("Modelo")) {
                        styledDoc.insertString(styledDoc.getLength(), "\n    " + linea + "\n", atributos);
                    } else {
                        styledDoc.insertString(styledDoc.getLength(), "    " + linea + "\n", atributos);
                    }
                }
            }
        } catch (BadLocationException ble) {
            System.err.println("Error while inserting instructions in the panel");
        }
        textoPC.moveCaretPosition(0);
    }

    //Muestra los modelos de simulación generados
    public void imprimeModSimPanelGMS(ArrayList<String> modelosSimulacion) {
        textoResultadoModSim.setText("");
        StyledDocument styledDoc = textoResultadoModSim.getStyledDocument();
        SimpleAttributeSet atributos = new SimpleAttributeSet();
        try {
            StyleConstants.setBold(atributos, true);
            StyleConstants.setFontSize(atributos, 14);
            Iterator i = modelosSimulacion.iterator();
            while (i.hasNext()) {
                String linea = (String) i.next();
                if (linea.startsWith("Modelo")) {
                    styledDoc.insertString(styledDoc.getLength(), "\n" + linea + "\n", atributos);
                } else {
                    styledDoc.insertString(styledDoc.getLength(), linea + "\n", atributos);
                }
            }
        } catch (BadLocationException ble) {
            System.err.println("Error while inserting instructions in the panel");
        }
    }

    public void imprimeModeloPanelDX(ModeloSistema modelo) {
        textoDX.setText("");
        StyledDocument styledDoc = textoDX.getStyledDocument();
        SimpleAttributeSet atributos = new SimpleAttributeSet();
        try {
            styledDoc.insertString(styledDoc.getLength(), "\nSystem Inputs (X, Y, U, Theta):\n", atributos);
            Iterator i = modelo.listaVariables.iterator();
            while (i.hasNext()) {
                styledDoc.insertString(styledDoc.getLength(), "    " + i.next() + "\n", atributos);
            }
            
            styledDoc.insertString(styledDoc.getLength(), "\nSimulation Models\n", atributos);
            i = modelo.listaModSim.iterator();
            while (i.hasNext()) {
                ModeloSimulacion modSim = (ModeloSimulacion) i.next();
                styledDoc.insertString(styledDoc.getLength(), "    " + modSim.nombreFichero + "\n", atributos);
                Iterator j = modSim.listaEcuaciones.iterator();
                while (j.hasNext()) {
                    String ecuacion = (String) j.next();
                    styledDoc.insertString(styledDoc.getLength(), "    " + ecuacion + "\n", atributos);
                }
                styledDoc.insertString(styledDoc.getLength(), "\n", atributos);
            }
        } catch (BadLocationException ble) {
            System.err.println("Error while inserting instructions in the panel");
        }
        textoDX.moveCaretPosition(0);
    }

    public void imprimeTablaExpDX(DefaultTableModel modelo) {
        tablaExpDX.setModel(modelo);
        tablaExpDX.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
        DefaultTableCellRenderer tcr = new DefaultTableCellRenderer();
        tcr.setHorizontalAlignment(SwingConstants.CENTER);
        for (int i = 0; i < modelo.getColumnCount(); i++) {
            tablaExpDX.getColumnModel().getColumn(i).setCellRenderer(tcr);
        }
        //Centramos los headers, necesario si usamos el Look & Feel del sistema
        TableCellRenderer rendererFromHeader = tablaExpDX.getTableHeader().getDefaultRenderer();
        JLabel headerLabel = (JLabel) rendererFromHeader;
        headerLabel.setHorizontalAlignment(JLabel.CENTER);
        tablaExpDX.setVisible(true);
        tablaExpDX.setEnabled(false);

    }

    public void imprimeTablaResiduos(DefaultTableModel modelo) {
        verGraficoDX.setVisible(true);
        tablaResiduos.setModel(modelo);
        tablaResiduos.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
        DefaultTableCellRenderer tcr = new DefaultTableCellRenderer();
        tcr.setHorizontalAlignment(SwingConstants.CENTER);
        for (int i = 0; i < modelo.getColumnCount(); i++) {
            tablaResiduos.getColumnModel().getColumn(i).setCellRenderer(tcr);
            if (i==0) {
                tablaResiduos.getColumnModel().getColumn(i).setPreferredWidth(50);
            } else {
                tablaResiduos.getColumnModel().getColumn(i).setPreferredWidth(135);
            }
        }
        //Centramos los headers, necesario si usamos el Look & Feel del sistema
        TableCellRenderer rendererFromHeader = tablaResiduos.getTableHeader().getDefaultRenderer();
        JLabel headerLabel = (JLabel) rendererFromHeader;
        headerLabel.setHorizontalAlignment(JLabel.CENTER);
        tablaResiduos.setVisible(true);
        tablaResiduos.setEnabled(false);
    }

    public void imprimeCandidatos(ArrayList<ArrayList<String[]>> candidatos, ArrayList<Diagnosis.CEM> CEMsSistema,
            ArrayList<String> ModelosActivados, ArrayList<Double> instantes, ArrayList<String> nodosDiscrepancia) {
        
        textoResultadoDX.setText("");
        StyledDocument styledDoc = textoResultadoDX.getStyledDocument();
        SimpleAttributeSet atributos = new SimpleAttributeSet();
        try {
            styledDoc.insertString(styledDoc.getLength(), "\nDiagnosis Report\n", atributos);
            styledDoc.insertString(styledDoc.getLength(), "========================\n", atributos);
            Calendar c1 = Calendar.getInstance();
            String fecha = "Init Date: " + Integer.toString(c1.get(Calendar.DATE))
                    + "/" + Integer.toString(c1.get(Calendar.MONTH) + 1)
                    + "/" + Integer.toString(c1.get(Calendar.YEAR));
            styledDoc.insertString(styledDoc.getLength(), "\n" + fecha + "\n", atributos);

            String discrepancias = "Discrepancy Nodes:";
            for (int i = 0; i < nodosDiscrepancia.size(); i++) {
                discrepancias = discrepancias + "\n" + nodosDiscrepancia.get(i);
            }
            styledDoc.insertString(styledDoc.getLength(), discrepancias + "\n", atributos);
            styledDoc.insertString(styledDoc.getLength(), "========================\n", atributos);

            styledDoc.insertString(styledDoc.getLength(), "\nList of CEMs\n", atributos);
            styledDoc.insertString(styledDoc.getLength(), "------------------\n", atributos);
            String linea;
            for (int i = 0; i < CEMsSistema.size(); i++) {
                Diagnosis.CEM cadena = CEMsSistema.get(i);
                linea = cadena.name + ":";
                for (int j = 0; j < cadena.candName.size(); j++) {
                    linea = linea + " " + cadena.candName.get(j);
                }
                styledDoc.insertString(styledDoc.getLength(), linea + "\n", atributos);
            }
            styledDoc.insertString(styledDoc.getLength(), "========================\n", atributos);

            styledDoc.insertString(styledDoc.getLength(), "\nStarting candidates calculation\n", atributos);
            styledDoc.insertString(styledDoc.getLength(), "------------------------\n", atributos);
            if (instantes.size() < 1) {
                styledDoc.insertString(styledDoc.getLength(), "\nThere are no PCs activated\n", atributos);
            }
            for (int i = 0; i < instantes.size(); i++) {
                styledDoc.insertString(styledDoc.getLength(), "\nInstant: " + instantes.get(i) + "\n", atributos);
                styledDoc.insertString(styledDoc.getLength(), "Activated PC: " + ModelosActivados.get(i) + "\n", atributos);
                linea = "Current candidate set:";
                ArrayList<String[]> activacionActual = candidatos.get(i);
                for (int j = 0; j < activacionActual.size(); j++) {
                    String candidato = "";
                    String[] elemento = activacionActual.get(j);
                    for (int k = 0; k < elemento.length; k++) {
                        candidato = candidato + elemento[k] + " ";
                    }
                    linea = linea + " [ " + candidato + "]";
                }
                styledDoc.insertString(styledDoc.getLength(), linea + "\n", atributos);
            }
        } catch (BadLocationException ble) {
            System.err.println("Error while inserting data in the panel");
        }
        textoResultadoDX.moveCaretPosition(0);
    }
}
