/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package generadorexperimentosdiagnosis;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Toolkit;
import java.io.File;
import javax.swing.JEditorPane;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JTree;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeSelectionListener;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeCellRenderer;
import javax.swing.tree.TreeSelectionModel;

/**
 *
 * @author David Rubio + Luis Miguel Villarroel
 */
public class VentanaAyuda extends JFrame {
    String helpURL;
    JPanel Principal;
    JEditorPane panelTexto = new JEditorPane();
    JScrollPane scrollTexto = new JScrollPane(panelTexto);
    JTree menuArbol = new JTree();
    JSplitPane panelDivisor = new JSplitPane();

    public VentanaAyuda() {
        setSize(new Dimension(640, 480));
        setTitle("Help");
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        Dimension frameSize = this.getSize();
        if (frameSize.height > screenSize.height) {
            frameSize.height = screenSize.height;
        }
        if (frameSize.width > screenSize.width) {
            frameSize.width = screenSize.width;
        }
        setLocation((screenSize.width - frameSize.width) / 2,
                (screenSize.height - frameSize.height) / 2);
        try {
            jbInit();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    private void jbInit() throws Exception {
        Principal = (JPanel) getContentPane();
        Principal.setLayout(new BorderLayout());
        helpURL = "help/" + "/index.html";

        DefaultMutableTreeNode top = new DefaultMutableTreeNode(new eleAyuda("Help", helpURL));
        createNodes(top);
        menuArbol = new JTree(top);
        menuArbol.getSelectionModel().setSelectionMode(TreeSelectionModel.SINGLE_TREE_SELECTION);

        //Escucha cuando cambia la selección.
        menuArbol.addTreeSelectionListener(new TreeSelectionListener() {
            public void valueChanged(TreeSelectionEvent e) {
                DefaultMutableTreeNode node = (DefaultMutableTreeNode) (e.getPath().getLastPathComponent());
                Object nodeInfo = node.getUserObject();
                eleAyuda elemento = (eleAyuda) nodeInfo;
                displayURL(elemento.eleURL);
            }
        });

        DefaultTreeCellRenderer renderer = new DefaultTreeCellRenderer();
        renderer.setBackgroundNonSelectionColor(new Color(136, 153, 183));
        renderer.setBackgroundSelectionColor(new Color(136, 153, 183));
        renderer.setTextNonSelectionColor(new Color(255, 255, 255));
        renderer.setTextSelectionColor(new Color(255, 255, 255));
        menuArbol.setCellRenderer(renderer);
        menuArbol.setBackground(new Color(136, 153, 183));
        panelTexto.setEditable(false);

        Principal.add(panelDivisor, java.awt.BorderLayout.CENTER);
        panelDivisor.add(menuArbol, JSplitPane.LEFT);
        panelDivisor.add(scrollTexto, JSplitPane.RIGHT);
        panelDivisor.setDividerLocation(200);
        displayURL(helpURL);
    }

    private void createNodes(DefaultMutableTreeNode top) {
        String dir = "help/";
        DefaultMutableTreeNode category = new DefaultMutableTreeNode(new eleAyuda("Intro", dir + "/intro.html"));
        top.add(category);
        
        //Ayuda sobre los ficheros de entrada y salida de la herramienta
        category = new DefaultMutableTreeNode(new eleAyuda("Files", dir + "/files.html"));
        DefaultMutableTreeNode moduloCM = new DefaultMutableTreeNode(new eleAyuda("Model converter", dir + "/filesCM.html"));
        category.add(moduloCM);
        DefaultMutableTreeNode moduloGE = new DefaultMutableTreeNode(new eleAyuda("Experiment generator", dir + "/filesGE.html"));
        category.add(moduloGE);
        DefaultMutableTreeNode moduloGMS = new DefaultMutableTreeNode(new eleAyuda("Simulation Models generator", dir + "/filesGMS.html"));
        category.add(moduloGMS);
        DefaultMutableTreeNode moduloDX = new DefaultMutableTreeNode(new eleAyuda("Diagnosis", dir + "/filesDX.html"));
        category.add(moduloDX);
        top.add(category);
    }

    public void displayURL(String url) {
        try {
            panelTexto.setPage(new File(url).toURL());
        } catch (Exception e) {
            System.out.println("File " + url + " not found.");
        }
    }

    private class eleAyuda {

        public String eleName;
        public String eleURL;

        public eleAyuda(String elemento, String fichero) {
            eleName = elemento;
            eleURL = fichero;
        }

        //Esto es lo que se mostrará en el árbol.
        public String toString() {
            return eleName;
        }
    }
}
